<?php

require_once __DIR__ . '/inc/site-options.php';

/**
 * 七牛CDN相关设置
 * 主要方法是使用字符替代函数替代默认多媒体文件网址
 */
if( !is_admin()&&!isset($_GET['edit'])&&!isset($_GET['new']) ) {
	add_action('wp_loaded','bno_ob_start');
	
	function bno_ob_start() {
		ob_start('bno_qiniu_cdn_replace');
	}

	function bno_qiniu_cdn_replace($html){
		$local_host = 'http://douhua.fun/wp-content/'; //博客域名
		$qiniu_host = 'http://douhua.wpabc.cc/'; //七牛域名
	
		$html =  str_replace($local_host, $qiniu_host , $html);			
		return $html;
	}
}

/**
 * 插入最后评论时间
 * 每评论一次，更新一次_comment_last 字段
 */

add_action('publish_topic','bno_init_comment_last');
add_action('publish_video','bno_init_comment_last');
add_action('publish_post','bno_init_comment_last');
function bno_init_comment_last( $post_id,$status){//初始化_comment_last
	$comment_date = get_post( $post_id )->post_date;
	update_post_meta($post_id,'_comment_last',$comment_date);//子
}
 
add_action( 'comment_post', 'bno_comment_last', 10, 2 );
add_action('publish_topicreply','bno_reply_last');
function bno_comment_last( $comment_ID, $comment_approved ) {
	if( 1 === $comment_approved ){
		$post_id = get_comment( $comment_ID )->comment_post_ID;
		$comment_date = get_comment( $comment_ID )->comment_date;
		update_post_meta($post_id,'_comment_last',$comment_date);//子
		
		$parent = get_post( $post_id )->post_parent;
		if($parent !== 0)update_post_meta($parent,'_comment_last',$comment_date);//父
	}
}
function bno_reply_last( $post_id,$status ) {
	$comment_date = get_post( $post_id )->post_date;
	$parent = get_post( $post_id )->post_parent;
	update_post_meta($parent,'_comment_last',$comment_date);//父
	update_post_meta($post_id,'_comment_last',$comment_date);//子
}

/**
 * 禁用Gravatar,同样会禁用get_avatar这个函数，这里重定义了该函数
 */
add_filter( 'get_avatar' , 'bno_custom_avatar' , 1 , 5 );

function bno_custom_avatar( $avatar, $id_or_email, $size, $default, $alt) {
	
		if ( is_numeric($id_or_email) )
			$user_id = (int) $id_or_email;
		elseif ( is_string( $id_or_email ) && ( $user = get_user_by( 'email', $id_or_email ) ) )
			$user_id = $user->ID;
		elseif ( is_object( $id_or_email ) && ! empty( $id_or_email->user_id ) )
			$user_id = (int) $id_or_email->user_id;
			
		$avatar_id = get_user_meta( $user_id, 'avatar_id', true );
		$avatar_url = wp_get_attachment_image_src( $avatar_id, 'square' , false )[0];
 
		if ( empty($user_id) || empty($avatar_url) ) {			
			$src = home_url('assets/images/avatar.jpg'); 
			$avatar = "<img alt='{$alt}' src='{$src}' height='{$size}' width='{$size}' />";
		} else {
			$avatar = "<img alt='{$alt}' src='{$avatar_url}' height='{$size}' width='{$size}' />";
		}
		if ( empty($user_id)) $url = wp_login_url();
		if ( !empty($user_id)) $url = get_author_posts_url($user_id);
		$avatar = '<a class="avatar" href="'.$url.'">'.$avatar.'</a>';

    return $avatar;
}

/**
* 生成随机数字和字符串
*/
function getRandomString($len, $chars=null){	
    if (is_null($chars))$chars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
    mt_srand(10000000*(double)microtime());	
    for ($i = 0, $str = '', $lc = strlen($chars)-1; $i < $len; $i++){$str .= $chars[mt_rand(0, $lc)]; }
    return $str;
}

//加载cmb2
if ( file_exists( __DIR__ . '/cmb2/init.php' ) ) { 
		require_once __DIR__ . '/cmb2/init.php';
	} elseif ( file_exists(  __DIR__ . '/CMB2/init.php' ) ) {
	  require_once __DIR__ . '/CMB2/init.php';
} 
//加载pingyin
if( file_exists( __DIR__ . '/inc/pinyin.php' ) ) require_once __DIR__ . '/inc/pinyin.php';

 /**
 * WordPress 媒体库只显示用户自己的文章和上传的文件
 * 在文章编辑页面的[添加媒体]只显示用户自己上传的文件
 */
function bno_upload_media( $wp_query_obj ) {
	global $current_user, $pagenow;
	if( !is_a( $current_user, 'WP_User') )
		return;
	if( 'admin-ajax.php' != $pagenow || $_REQUEST['action'] != 'query-attachments' )
		return;
	if( !current_user_can( 'manage_options' ) && !current_user_can('manage_media_library') )
		$wp_query_obj->set('author', $current_user->ID );
	return;
}
add_action('pre_get_posts','bno_upload_media'); 

//add dynamic ID for wp_nav_menu after and before
function custom_walker_nav_menu_start_el($item_output, $item, $depth, $args){
	$menu_locations = get_nav_menu_locations();

	if( $item->object == 'topic-types' ) {
		$icon_name = get_template_directory_uri().'/images/icon/'.get_term($item->object_id,'topic-types')->slug.'.jpg';
		$output = '<img class="topicat" height="25" width="25" src="'.$icon_name.'"/><span class="nav-item">';
		$output .= $item_output;
		$output .= '</span>';
	} elseif( has_term($menu_locations['header-menu'], 'nav_menu', $item) ){
		$icon_name = get_template_directory_uri().'/images/icon/main'.$item->object_id.'.svg';
		$output = '<span class="topicat maincat">'.file_get_contents($icon_name).'</span><span class="nav-item">';
		$output .= $item_output;
		$output .= '</span>';
	} else {
		$output = '<span class="nav-item">';
		$output .= $item_output;
		$output .= '</span>';	 
	}
	return $output;
}
add_filter( 'walker_nav_menu_start_el', 'custom_walker_nav_menu_start_el' , 10, 4 );

//不同页面图片库选择不同extensions
function my_myme_types($mime_types){
	
	if(is_singular('topic')||is_singular('video')){
		$mime_types = array(
			'mp4' => 'video/mp4',
			'jpg|jpeg|jpe' => 'image/jpeg',
			'gif' => 'image/gif',
			'png' => 'image/png',
			'bmp' => 'image/bmp',			
		);
	}	
	if(isset($_GET['new'])&&($_GET['new']=='v')){
		$mime_types = array(
			'mp4' => 'video/mp4',			
		);
	} elseif(is_admin()) {
		$mime_types = array(
			'jpg|jpeg|jpe' => 'image/jpeg',
			'gif' => 'image/gif',
			'png' => 'image/png',
			'bmp' => 'image/bmp',
			'mp4' => 'video/mp4',
			'flv' => 'video/flv',
			'tif|tiff' => 'image/tiff',
			'zip' 	   => 'application/zip',				
			'gzip'     => 'application/x-gzip',
			'pdf'      => 'application/pdf',
			'doc' => 'application/msword',
			'docx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
			'ppt' => 'application/vnd.ms-powerpoint',
			'pptx' => 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
			'ppsx' => 'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
			'xls' => 'application/vnd.ms-excel',
			'xlsx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
			'txt' => 'text/plain',
			'vtt' => 'text/plain',
		);
	}  else {
		$mime_types = array(
			'jpg|jpeg|jpe' => 'image/jpeg',
			'gif' => 'image/gif',
			'png' => 'image/png',
			'bmp' => 'image/bmp',
		);
	}
    return $mime_types;
}
add_filter('upload_mimes', 'my_myme_types', 1, 1);


/**
 *WordPress 不用修改文件解决定时发布文章失败
 *
*/

function Bing_cron_request($request){

    $request['args']['timeout']=2;//如果还不能发布把 2 适当改大

    return$request;

}

add_filter('cron_request','Bing_cron_request');

// 删除文章时删除图片附件
function delete_post_and_attachments($post_ID) {
    global $wpdb;
    //删除图片附件
    $attachments = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_parent = $post_ID AND post_type = 'attachment'" );
        foreach ( $attachments as $attachment ) {
			$path = dirname($_SERVER['DOCUMENT_ROOT'].'/wp-content/uploads/'.get_post_meta($attachment->ID,'_wp_attached_file',true));
			wp_delete_attachment( $attachment->ID, true );
			rmdir($path);
        }
    $wpdb->query( "DELETE FROM $wpdb->postmeta WHERE meta_key = '_thumbnail_id' AND post_id = $post_ID" );
	//child 回应
	$replys = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE post_parent = $post_ID AND post_type = 'topicreply'" );
		foreach($replys as $reply){
			wp_delete_post($reply->ID, true);
		}	
}
add_action('before_delete_post', 'delete_post_and_attachments');

// 评论添加@
function bno_comment_add_at( $comment_text, $comment = '') {
  if( $comment->comment_parent > 0) {
    $comment_text = '@<a class="at" href="#comment-' . $comment->comment_parent . '">'.get_comment_author( $comment->comment_parent ) . '</a> ' . $comment_text;
  }
  return $comment_text;
}
add_filter( 'comment_text' , 'bno_comment_add_at', 20, 2);
 
// 设置文章别名为拼音+id
add_action( 'save_post', 'using_pyid_as_slug', 10, 2 );
function using_pyid_as_slug($post_id, $post){	
	global $post_type;
	if( $post_type == 'post' || $post_type == 'album' || $post_type == 'topicreply' || $post_type == 'video'|| $post_type == 'topic' ){
		//如果是文章的版本，不生效
		if (wp_is_post_revision($post_id))return false;
		//取消挂载该函数，防止无限循环
		remove_action('save_post', 'using_pyid_as_slug' );
		if( strpos($post->post_name,"_") !== 15  || !ctype_alnum(substr($post->post_name))) {//规则从0开始 下划线在第15位 数字字母下划线
			//使用文章ID作为文章的别名
			wp_update_post(array('ID' => $post_id, 'post_name' => substr(md5('jswdwsxyxyzshn'.$post_id), 0, 15).'_'.$post_id.'_thread'));
		}
		//重新挂载该函数
		add_action('save_post', 'using_pyid_as_slug' );
	}
} 

/**
 * 仅允许搜索指定文章类型.
 * @since BlueRed 1.0
 */
function bno_filter_search($query) {
	if (!$query->is_admin && $query->is_search) {
		$query->set('post_type', array('post', 'case', 'photo', 'album', 'video', 'topic','topicreply','sp'));
	}
	return $query;
}
add_filter('pre_get_posts', 'bno_filter_search');

/**
 * Some other settings.
 * @since BlueRed 1.0
 */

//自定义菜单
register_nav_menus(array(
         'header-menu' => __( '主导航菜单' ),
         'service-nav' => __( '服务导航' ),	
		 'service-page-nav' => __( '服务页导航' ),			 
		 'case-nav' => __( '案例导航' ),		 
         'home-left' => __( '首页左边栏' ),
         'footer-menu' => __( '页脚导航菜单' ),
		 'footer-right' => __( '页脚右侧菜单' ),
         'user-page-menu' => __( '用户主页导航' ), 
         'user-help-nav' => __( '帮助信息' ),	
         'page-nav' => __( '网站页面导航' ),
		 'mobile-nav' => __( '移动端导航' ),//当前使用修改的twentyfifteen	
		 'mobile-home-nav' => __( '移动端主页导航' ),	
		 'mobile-sve-nav' => __( '移动端服务页底部导航' ),		 
    ) );

//启用post thumbnail
if ( function_exists( 'add_theme_support' ) ) {
    add_theme_support( 'post-thumbnails' );
	add_image_size('square',150,150,true);
}
//only work when added new
add_filter( 'post_thumbnail_html', 'remove_width_attribute', 10 );
add_filter( 'image_send_to_editor', 'remove_width_attribute', 10 );
function remove_width_attribute( $html ) {
   $html = preg_replace( '/(width|height)="\d*"\s/', "", $html );
   return $html;
}

//登陆页面密码账号为空时的跳转设定
function verify_user_pass($user, $username, $password) {
	$login_page  = home_url('/login');
	if($username == '' || $password == '') {
		wp_redirect($login_page . '?login=empty');
		exit;
	}
} 
add_filter('authenticate', 'verify_user_pass', 1, 3); 

// WordPress 禁止用户注册某些用户名
function sozot_validate_username($valid, $username ) {
	$forbidden = array('directory', 'admin','domain','profile', 'download', 'downloads', 'edit', 'editor', 'email', 'ecommerce', 'forum', 'forums', 'favorite', 'feedback', 'follow', 'files', 'gadget', 'gadgets', 'games', 'guest', 'group', 'groups', 'homepage', 'hosting', 'hostname', 'httpd', 'https', 'information', 'image', 'images', 'index', 'invite', 'intranet', 'indice', 'iphone', 'javascript', 'knowledgebase', 'lists','websites', 'webmaster', 'workshop', 'yourname', 'yourusername', 'yoursite', 'yourdomain','管理员','超级管理员','网站管理员','站长','客服','网站客服','在线客服','在线管理员','在线站长');
	$pages = get_pages();
	foreach ($pages as $page) {
		$forbidden[] = $page->post_name;
	}
	if(!$valid || is_user_logged_in() && current_user_can('create_users') ) return $valid;
	$username = strtolower($username);
	if ($valid && strpos( $username, ' ' ) !== false) $valid=false;
	if ($valid && in_array( $username, $forbidden )) $valid=false;
	if ($valid && strlen($username) < 5) $valid=false;

	return $valid;
}
add_filter('validate_username', 'sozot_validate_username', 10, 2);

//错误提示
function sozot_registration_errors($errors) {
	if ( isset( $errors->errors['invalid_username'] ) )
		$errors->errors['invalid_username'][0] = __( '错误：该用户名不允许注册！', 'sozot' );
	return $errors;
}
add_filter('registration_errors', 'sozot_registration_errors');

//非给定字符文件名上传时重命名
function new_filename($filename) {
	$info = pathinfo($filename);
	$ext = empty($info['extension']) ? '' : '.' . $info['extension'];
	$name = basename($filename, $ext);
	$name = substr(md5($name), 0, 15);
	return 'attachment-'.getRandomString(6).$name . $ext;
}
add_filter('sanitize_file_name', 'new_filename', 10);

//解决文章列表分页链接无效问题
add_filter('redirect_canonical','pif_disable_redirect_canonical');
function pif_disable_redirect_canonical($redirect_url) {
    if (is_singular()) $redirect_url = false;
	return $redirect_url;
}

//保护后台登录
add_action('login_enqueue_scripts','login_protection');  
function login_protection(){  
    if($_GET['site'] != 'admin-board')header('Location: '.home_url().'');  
}

//非管理员禁止进入后台
add_action('admin_init', 'prevent_user_get_dashboard');
function prevent_user_get_dashboard() {
	if ( is_admin() && ! current_user_can( 'administrator' ) &&	! ( defined( 'DOING_AJAX' ) && DOING_AJAX ) ) {
		wp_redirect( home_url() );
		exit;
	}
}

// 添加忘记密码选项
add_action( 'login_form_middle', 'add_lost_password_link' );
function add_lost_password_link() {
    return '<div class="text-link right" style="line-height:70px;"><a href="'.home_url('/register').'">注册</a>&nbsp;|&nbsp;<a href="'.home_url('/').'wp-login.php?action=lostpassword">忘记密码？</a></div>';
}

/* 
**加载其他功能函数
*/
require_once __DIR__ . '/inc/custom-types.php';
require_once __DIR__ . '/inc/cmb2-metaboxes.php';
require_once __DIR__ . '/inc/cmb2-custom-fileds.php';
require_once __DIR__ . '/inc/new-post-frontend.php'; 
require_once __DIR__ . '/inc/edit-frontend.php';
require_once __DIR__ . '/inc/other-cpt-frontend.php';
require_once __DIR__ . '/inc/adding-functions.php';
require_once __DIR__ . '/inc/nickname-unique.php'; 

//引用
add_filter( 'embed_oembed_html', 'wrap_oembed_html', 99, 4 );
function wrap_oembed_html( $cached_html, $url, $attr, $post_id ) {
	if(strpos($url,'_thread')==false) return;
	$object_id  = substr($url,strpos($url,'_')+1,strpos($url,'_thread')-strpos($url,'_')-1);
	$object = inner_site_quote($object_id,$url);
    return $object;
}

function inner_site_quote($object_id,$url){
	if(strpos($url,'tid-')==true) {
		$tid = substr($url,strpos($url,'tid-')+4,strpos($url,'-reply')-strpos($url,'tid-')-4);
		$trul = bno_topicreply_link($tid);
		$trul = $trul['page'];
	}else{
		$tid = $object_id;
		$trul = get_permalink($object_id);
	}
	$object = get_post($object_id);
	$cache .= '<div class="box-inner quote-box"><div class="quote-header">';
	$cache .= '<div class="right"><div class="metabar"><label class="rdobox">'.get_avatar($object->post_author, 20 ).'<span class="count">'.get_the_author_meta('display_name',$object->post_author).'</span></label><label class="rdobox"><span class="count">'.get_comments_number($tid).' 评论</span></label></div></div>';
	$cache .= '<h4><a target="_blank" href="'.$trul.'">'.file_get_contents(home_url('/assets/svg/quote.svg'));
	if($object->post_type=='topic' ){
		$floor = $ct = '';
		if(strpos($url,'tid-')==true) {
			$floor = '#'.get_post_meta($tid,'thread_num',true);
			$ct = '<div class="hr"></div></div>'.bno_topic_display($tid);
		} else{
			$ct = '<div class="hr"></div></div>'.bno_topic_display($object_id);
		}
		$cache .= mb_strimwidth(strip_tags(apply_filters('the_title', $object->post_title)), 0, 36,'...').$floor.'</a></h4>'.$ct;
	} elseif($object->post_type=='video'){
		$cache .= mb_strimwidth(strip_tags(apply_filters('the_title', $object->post_title)), 0, 36,'...').'</a></h4>';
		$cache .= '</div><div class="video">'.bno_video_player($object_id,'568','320').'</div>';
	} else {
		$cache .= mb_strimwidth(strip_tags(apply_filters('the_title', $object->post_title)), 0, 36,'...').'</a></h4>';
		$cache .= '<div class="hr"></div></div>'.mb_strimwidth(strip_tags(apply_filters('the_content', $object->post_content)), 0, 360,'...');
	}
	$cache .= '</div>';
	return $cache;
}

function bno_topic_display($object_id){
	$post = get_post($object_id);
	$web_videos = get_post_meta($post->ID,'topic_imgurls',true);
	foreach($web_videos as $k => $v){
		if((strpos($v,'youku.com')!==false)||(strpos($v,'qq.com')!==false)||(strpos($v,'bilibili.com')!==false))
			$webv[$k] = $v;
	}
	if(!empty($webv)){
		foreach($webv as $v){
			$ct = bno_video_player($post->ID,'568','320','video_reprint',$v);
		}
	} else {
		$c = $post->post_content;
		$videos = get_attached_media('video', $post->ID);						
		if(!empty($videos)&&$post->post_type == 'topic') {
			$videos = get_attached_media('video', $post->ID);// video box
			if(count($videos) !== 0) {
				foreach($videos as $video){
					$ct .= bno_video_player($video->ID,'568','320','video_upload','','topic');
				}
			}
		} elseif(!empty($c)&&($post->post_type == 'topicreply' || $post->post_type == 'topic')) {
			$ct .= $post->post_content;
		}
	}
	if( $post->post_type == 'video'):
		$sharemode = get_post_meta($post->ID,'video_sharemode',true); 
		$gif = get_post_meta($post->ID,'add_gifplayer',true); 
		if(($sharemode == 'video_upload')&&($gif == 'on')) {
			$poster = cwg_get_background_image($file_ID,'large');
			$ct .= '<img class="gifs" data-mode="video" data-webm="'.get_post_meta($post->ID,'video',true).'" data-mp4="'.get_post_meta($post->ID,'video',true).'" src="'.$poster.'">';
		} else{
			$ct .= bno_video_player($post->ID,'568','320');
		}
	endif;	
	return $ct;
}

//输出幻灯专用缩略图
function bno_lister_img_src($image_id , $size){
	global $post;
		$img = wp_get_attachment_image_src( $image_id , $size );
		if( !empty($img) ){
			return $img_src = $img[0] ;
			}
}

//输出文章列表缩略图
function cwg_get_background_image($post_id,$size){
    if( has_post_thumbnail($post_id) ){
		if( empty($size) ) $size = 'full';
        $timthumb_src = wp_get_attachment_image_src(get_post_thumbnail_id($post_id),$size);
        $output = $timthumb_src[0];
    } else {
        $content = get_post_field('post_content', $post_id);
        $defaltthubmnail = get_template_directory_uri().'/images/avatar/'.rand(1,20).'.jpg';
        preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $content, $strResult, PREG_PATTERN_ORDER);
        $n = count($strResult[1]);
       if($n > 0){
            $output = $strResult[1][0];
        } else {
            $output = $defaltthubmnail;
        }
    }
    return $output;
}

//输出图片链接
function post_thumbnail_src($post_id){
	global $post;
	if ( has_post_thumbnail() ){
	$thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($post_id),'thumbnail');
	$post_thumbnail_src = $thumbnail_src[0];
	} else {
		$post_thumbnail_src = '';
	}
	echo $post_thumbnail_src;
}

//输出文章缩略图
function bno_post_thumbnail($post_id,$width,$height){
	echo '<img src="';
	echo post_thumbnail_src($post_id);
	echo '" text="" thumb="" alt="'.get_the_title().'" width="'.$width. '" height="'.$height.'" />';
}

//通过$src输出文章缩略图
function bno_src_post_thumbnail($src,$width,$height){
	echo '<img src="';	
	echo $src;
	echo '" alt="" width="'.$width. '" height="'.$height.'" />';
}

//获取自定义字段文章数量
function bno_get_post_count_by_metakey($type,$key,$val) {
	$args = array(
		'post_type' => $type,
		'meta_query' => array(
			array(
				'key' => $key, 
				'value' => $val,
				'compare' => 'LIKE'
				)),
		);
	$query = new WP_Query( $args );
	$count = $query->found_posts;	
	return $count;
}

function makes_time_ago() {
	return human_time_diff( get_the_time( 'U' ), current_time( 'timestamp' )-28800 ).''.__( '前' );
}

//文章列表分页
function par_pagenavi($range = 9){
	global $paged, $wp_query;
	if ( !$max_page ) {$max_page = $wp_query->max_num_pages;}
	if($max_page > 1){if(!$paged){$paged = 1;}
	if($paged != 1){echo "<a href='" . get_pagenum_link(1) . "' class='extend' title='跳转到第一页'>最前</a>";}
	previous_posts_link(' 上一页 ');
    if($max_page > $range){
		if($paged < $range){for($i = 1; $i <= ($range + 1); $i++){echo "<a href='" . get_pagenum_link($i) ."'";
		if($i==$paged)echo " class='current'";echo ">$i</a>";}}
    elseif($paged >= ($max_page - ceil(($range/2)))){
		for($i = $max_page - $range; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";
		if($i==$paged)echo " class='current'";echo ">$i</a>";}}
	elseif($paged >= $range && $paged < ($max_page - ceil(($range/2)))){
		for($i = ($paged - ceil($range/2)); $i <= ($paged + ceil(($range/2))); $i++){echo "<a href='" . get_pagenum_link($i) ."'";if($i==$paged) echo " class='current'";echo ">$i</a>";}}}
    else{for($i = 1; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";
    if($i==$paged)echo " class='current'";echo ">$i</a>";}}
	next_posts_link(' 下一页 ');
    if($paged != $max_page){echo "<a href='" . get_pagenum_link($max_page) . "' class='extend' title='跳转到最后一页'>最后</a>";}}
}

//定义 topicreply 链接
function bno_topicreply_link($post_id){
	$reply = get_post($post_id);
	$args = array('post_parent'=>$reply->post_parent,'post_type'=>'topicreply','order'=>'ASC','numberposts'=>-1);
	$tys = get_posts($args);
	$link['max'] = count($tys);
	$i = 0;
	if($tys){
		foreach($tys as $v){	
			$i = $i + 1;
			if($v->ID == $post_id) break;
		}
	}
	$parentlink = get_permalink($reply->post_parent);
	$pnum = $i/24;
	$ppnum = intval($i/24);
	$pagenum = $ppnum;
	if($ppnum < $pnum )
		$pagenum = intval($i/24)+1;
	
	$pagtxt = '/page/'.$pagenum;
	if($pagenum == 1) $pagtxt = '';
	$link['page'] = filter_get_pagenum_link( $parentlink ).$pagtxt.'#tid-'.$post_id.'-reply';
	return $link;
}

// remove single page html when rewrite
function filter_get_pagenum_link( $result ) { 
    if(strpos($result,'.html')==true)
		$result  = str_replace('.html','',$result);
    return $result; 
}; 
add_filter( 'get_pagenum_link', 'filter_get_pagenum_link', 10, 1 ); 

// rewrite post name dont delete
/* add_action( 'admin_init', 'rename_postname' );
function rename_postname(){
	$args = array(
				'post_type'   => array('topicreply','topic','post','video','album' ),
				'post_status' => 'any',
				'numberposts' => -1,
			);
	$posts = get_posts($args);
	foreach($posts as $post):
		//if(strpos($post->post_name,'item_') == true){
			wp_update_post( array( 
				'ID' => $post->ID,
				'post_name'=> substr(md5('jswdwsxyxyzshn'.$post->ID), 0, 15).'_'.$post->ID.'_thread',
		) ); 
		//}
	endforeach;
} */

// update custom 'floor_tid'
/* add_action( 'admin_init', 'update_rename_postname' );
function update_rename_postname(){
	$args = array(
				'post_type'   => array('topic'),
				'post_status' => 'any',
				'numberposts' => -1,
			);
	$posts = get_posts($args);
	foreach($posts as $post):
		$aargs = array(
				'post_type'   => array('topicreply'),
				'post_status' => 'any',
				'post_parent' => $post->ID,
				'numberposts' => 1,
				'order' => 'DESC',
			);
		$replay = get_posts($aargs);
		 foreach($replay as $tid){
			 $tdinfo['tid'] = $tid->ID;
			 $trul = bno_topicreply_link($tid->ID);
			 break;
		 }
		 
		 $tdinfo['floor'] = get_post_meta($post->ID,'threads',true);
		 update_post_meta($post->ID,'floor_tid',$tdinfo);
		 update_post_meta($post->ID,'last_thread_url', $trul['page']);
	endforeach;
} */

//首页轮播图
function bno_home_slider_box($listerID,$width,$height,$pattern){ 
	$i= 0; 
	$custom = get_post_custom($listerID);
	$lister = unserialize( $custom['custom_lister'][0] );
	if( $lister ){?>		
        <div id="focus_box" style="width:<?php echo $width;?>px;height:<?php echo $height;?>px;background:#000;">
			<div id="focus">
				<div class="pic"> 
					<ul class="slider-pic">
					<?php foreach( $lister as $list ): ?>
						<li>
							<a href="<?php echo stripslashes( $list['link'] );?>">
								<img width="<?php echo $width;?>" height="<?php echo $height;?>" alt="<?php echo $list['title'];?>" src="<?php echo bno_lister_img_src($list['id'],$width,$height);?>"/>
							</a>
						</li>
					<?php if($i>4) break;else $i++;	endforeach; ?>	
					</ul>
				</div>
			</div>
			<div class="clear"></div>
		</div> 	
	<?php }?>
	<script type="text/javascript">
		myFocus.set({id: 'focus_box',pattern: '<?php echo $pattern; ?>',time: 3,trigger: 'mouseover',  delay: 500,  txtHeight: 'default'});
	</script>
	<?php
}

//lister图片展示基础版
function bno_lister_box($listerID,$width,$height,$number){ 
	$i= 0; 
	$custom = get_post_custom($listerID);
	$lister = unserialize( $custom['custom_lister'][0] );
	if( $lister ){?>		
        <div class="lister_box">
			<ul class="lister-pic">
				<?php foreach( $lister as $list ): ?>
					<li>
						<a href="<?php echo stripslashes( $list['link'] );?>">
							<img width="<?php echo $width;?>" width="<?php echo $height;?>" alt="<?php echo $list['title'];?>" src="<?php echo bno_lister_img_src($list['id'],$width,$height);?>"/>
						</a>
					</li>
				<?php if($i>$number) break;else $i++;	endforeach; ?>	
			</ul>
			<div class="clear"></div>
		</div> 	
	<?php }
	
}

//随机广告显示
function bno_advertise_box($listerID,$width,$height,$pattern){ 

	$custom = get_post_custom($listerID);
	$lister = unserialize( $custom['custom_lister'][0]);
	$num = count($lister); $i = rand(1,$num);
	if( $lister ){?>		
		<a href="<?php echo stripslashes( $lister[$i]['link'] );?>">
			<img height="<?php echo $height;?>" width="<?php echo $width;?>" alt="<?php echo $lister[$i]['title'];?>" src="<?php echo bno_lister_img_src($lister[$i]['id'], 'medium');?>"/>
		</a>
		<a class="ad-title" href="<?php echo stripslashes( $lister[$i]['link'] );?>"><?php echo $lister[$i]['title'];?></a>
		<div class="picle-sub"><span><?php echo get_post($listerID)->post_title; ?></span><span><?php _e('-广告',''); ?></span></div>
		<div class="clear"></div>
	<?php }
	
}

/**
 * 简码[article-meta-list num="" cat="" ……]
 */
function article_meta_list($atts, $content = null) {
	$retour ='';
	extract(shortcode_atts(array(
		"title" => '',
		"type" => '',
		"num" => '',
		"term" => '',
		'author'=> '',
		'box' =>'',
	), $atts));
	global $post;
		$args = '';
		if(empty($type))
			$type = array('topic','video','post');
			$args = array( 
				'numberposts' => $num, 
				'post_type' => $type,
				'author'=> $author,
				'meta_query' => array(
					'query_1' => array(
						'key' => 'vote-up_count',
						),
					'query_2' => array(
						'key' => 'views',
						),									
				),
				'orderby' => array(
					'meta_value_num' => 'DESC',
					'comment_count' => 'DESC',
					'query_1' => 'DESC',
					'query_2' => 'DESC',
				),
				
			); 
		$forcounts = new WP_Query($args);
		$counts = $forcounts->found_posts;
	if( $counts>0){
		$myposts = get_posts($args);
		_ex('<div class="listerBox">');
		if( !empty($title))
			_ex('<h3 class="listerh3">'.$title.'('.$counts.')</h3>');
		foreach($myposts as $post) :			
			echo get_template_part( 'content', $box );
		endforeach;	
		_ex('<div class="clear"></div></div>');
	}
}
add_shortcode('article-meta-list', 'article_meta_list');

//用户主页顶部
function bno_userHeader_box($curauth){ 
?>
	<div class="userhead">
		<div class="user-header home-box">
			<div class="box-inner">	
				<div class="left">
					<?php echo get_avatar($curauth->ID, 92 );?>
					<div class="upload-info">
						<h4 class="darkfont rdobox"><?php echo $curauth->display_name; ?></h4>
						<span class="rdobox"><?php echo get_user_meta($curauth->ID,'myslug',1);?></span>
						<span class="darkfont rdobox">
							<?php echo get_user_meta($curauth->ID,'focus_count',1); print '人关注&nbsp;&nbsp;';?>
							<?php echo get_user_meta($curauth->ID,'vote-up_count',1); print '赞';?>
						</span>
					</div>
				</div>
				<div class="right" style="margin-top: 12px;">
					<?php if($curauth->ID == wp_get_current_user()->ID):?>
					<?php if(empty($_GET['edit'])) { echo '<label class="rdobox right edit-link"><span><a class="post-edit-link" href="'.get_edit_user_link().'">'.file_get_contents(home_url('/assets/svg/pencil.svg')).'</a></span></label>'; } else {echo '<label class="rdobox right edit-remove"><span><a href="'.get_author_posts_url(wp_get_current_user()->ID).'">'; _e(''.file_get_contents(home_url('/assets/svg/remove.svg')).'&nbsp;取消',''); echo '</a></span></label>';}?>
					<?php else:?>
					<?php echo getAuthorStarLink($curauth->ID,'focus');?>
					<?php endif;?>
				</div>
				<div class="clear"></div>
			</div>	
		
		</div>
	</div>
<?php
}

//create thumbnail for video
function bno_create_video_thumbnail($attachment_id){
	
	$vrio = wp_get_attachment_url($attachment_id);
	if((strtolower(end(explode('.',$vrio)))!=='mp4')&&(strtolower(end(explode('.',$vrio)))!=='webm'))
		return false;
	
	$vri = $_SERVER['DOCUMENT_ROOT'].''.substr($vrio,strpos($vrio,'/wp-content'));
	if(strtolower(end(explode('.',$vri)))=='mp4'){
		$imgd = str_replace('.mp4','.jpg',$vri);
	}elseif(strtolower(end(explode('.',$vri)))=='webm'){
		$imgd = str_replace('.webm','.jpg',$vri);
	}
	$cmd = "/usr/bin/ffmpeg -i $vri -deinterlace -an -ss 0.01 -f mjpeg -t 1 -r 1 -y $imgd 2>&1";
	exec($cmd);
	
	$pid = wp_get_post_parent_id( $attachment_id );
	if($pid == 0)$pid = $attachment_id;
	
	$attachment_imgd = array(
		'guid'           => $imgd, 
		'post_mime_type' => 'image/jpeg',
		'post_title'     => get_the_title($pid),
		'post_status'    => 'inherit',
	);
	$attach_imgd_id = wp_insert_attachment( $attachment_imgd, $imgd, $pid );
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	require_once(ABSPATH . "wp-admin" . '/includes/file.php');
	require_once(ABSPATH . "wp-admin" . '/includes/media.php');
	$attach_imgd_data = wp_generate_attachment_metadata( $attach_imgd_id, $imgd );
	wp_update_attachment_metadata( $attach_imgd_id, $attach_imgd_data );
	
	wp_update_post( array( 'ID' => $attachment_id,'_thumbnail_id'=> $attach_imgd_id) );

}

add_filter('add_attachment', 'bno_create_video_thumbnail', 10, 1);

//从url下载图片（jpg）/视频(mp4)等
function get_media_downloader($post_id,$url,$type){
	
	$inpath = $type.'/'.date('Y',time()).'/'.date('m',time()).'/'.$post_id;
	$local_path = $_SERVER['DOCUMENT_ROOT'].'/wp-content/uploads/'.$inpath;
		if (!file_exists($local_path)) {
			mkdir($local_path,0777,true); 
		}
	if(strtolower(end(explode('.',$url)))=='mp4'){		
		$basicurl = substr($url,'0',stripos($url,'.mp4')+4);
	}elseif(strtolower(end(explode('.',$url)))=='webm'){
		$basicurl = substr($url,'0',stripos($url,'.webm')+5);
	}elseif(exif_imagetype($url)==IMAGETYPE_JPEG){
		$basicurl = substr($url,'0',stripos($url,'.jpg')+4);
	}elseif(exif_imagetype($url)==IMAGETYPE_PNG){
		$basicurl = substr($url,'0',stripos($url,'.png')+4);
	} else {
		break;
	}
	$newname=new_filename(basename($basicurl));
	$filename = $local_path.'/'.$newname;
	copy($url, $filename);	
			 
	$filetype = wp_check_filetype( basename( $filename ), null );
	$mime = $filetype['type'];
	if(strtolower(end(explode('.',$url)))=='mp4')$mime = 'video/mp4';//纠正MP4前端上传时mime不正确
	if(strtolower(end(explode('.',$url)))=='webm')$mime = 'video/webm';
	$attachment = array(
		'guid'           => $wp_upload_dir['url'].'/'.$inpath.'/'.$newname, 
		'post_mime_type' => $mime,
		'post_title'     => $url,//让标题与源文件名同名
		'post_status'    => 'inherit',
	);
	$attach_id = wp_insert_attachment( $attachment, $filename, $post_id );
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	require_once(ABSPATH . "wp-admin" . '/includes/file.php');
	require_once(ABSPATH . "wp-admin" . '/includes/media.php');
	$attach_data = wp_generate_attachment_metadata( $attach_id, $filename );
	wp_update_attachment_metadata( $attach_id, $attach_data );
	
	return $attach_id;
}

//收藏夹页面顶部
function bno_albumPageHeader_box($post_id, $bgsize){ 
?>
	<div class="albumheader gray" style="background-image:url(<?php echo cwg_get_background_image($post_id,$bgsize); ?>)">
		<div class="overlay"></div>
		<div class="album-header home-box txt-center">
				<h3 class="author-name"><?php echo get_post($post_id)->post_title;?></h3>		
		</div>
	</div>
	<div class="clear s_blank_space"></div>
		<div class="user-nav txt-center" >		
		<ul id="menu-user-page-nav" class="menu">
			<li class="menu-item"><a href="<?php echo get_post_permalink();?>">全部</a></li>
			<li class="menu-item"><a href="<?php echo get_post_permalink();?>?query=topic">帖子</a></li>	
			<li class="menu-item"><a href="<?php echo get_post_permalink();?>?query=post">长贴</a></li>	
			<li class="menu-item"><a href="<?php echo get_post_permalink();?>?query=video">视频</a></li>
		</ul>
<script type="text/javascript">
$(function(){
    var curl = location.href;
	if (curl.indexOf("?") !== -1 ) {
		var current = location.search;
		$('#menu-user-page-nav li a').each(function(){
			var $this = $(this);
			if($this.attr('href').indexOf(current) !== -1){
				$this.parent().addClass('current-menu-item');
			} 
		})		
	} else {
		$('#menu-user-page-nav li:first-child').addClass('current-menu-item');
	}
})
</script>	
		</div>
		
<?php
}


//收藏夹页面顶部
function bno_userleft_nav($user){ 
	if($user == wp_get_current_user()){$usrname = '我';} else {	$usrname = 'TA';}
?>
	<div class="grid_1">
		<div id="homeleft-nav">		
		<ul id="menu-left-nav" class="menu">
			<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>"><?php _ex($usrname.'的主页');?></a></li>
			<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>?query=topic"><?php _ex($usrname.'的帖子');?></a></li>
			<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>?query=post"><?php _ex($usrname.'的长贴');?></a></li>
			<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>?query=video"><?php _ex($usrname.'的视频');?></a></li>
			<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>?query=album"><?php  _ex($usrname.'的专辑');?></a></li>
			
			<?php if($user == wp_get_current_user()):?>
				<li class="menu-item"><a href="<?php echo get_edit_user_link();?>"><?php  _ex('账号安全');?></a></li>
				<li class="menu-item"><a href="<?php echo get_author_posts_url($user->ID);?>?query=data"><?php  _ex('数据统计');?></a></li>
			<?php endif;?>
			
		</ul>

	<script type="text/javascript">
	$(function(){
		var curl = location.href;
		if (curl.indexOf("?") !== -1 ) {
			var current = location.search;
			$('#menu-left-nav li a').each(function(){
				var $this = $(this);
				if($this.attr('href').indexOf(current) !== -1){
					$this.parent().addClass('current-menu-item');
				} 
			})		
		} else {
			$('#menu-left-nav li:first-child').addClass('current-menu-item');
		}
	})
	</script>
		</div>
	</div>
		
<?php
}

//重写默认播放器代码(先移除，再添加)
remove_shortcode('video');
add_shortcode('video', 'bno_video_shortcode');
function bno_video_shortcode($atts) {
    extract(shortcode_atts(array(
		"mp4" => '',
		"width" => 600,
		"height" => 340,
		"poster" => '',
	), $atts));
	$retour ='
	<video id="my-video" class="video-js" controls preload="auto" width="'.$width.'" height="'.$height.'" poster="'.$poster.'" data-setup="{}" >
		<source src="'.$mp4.'" type="video/mp4">
		<source src="'.$mp4.'" type="video/webm">
		<span class="vjs-no-js">正常播放视频请允许页面启用JavaScript, 或者升级浏览器到最新版本</span>
	</video><p></p>';
	return $retour;
}
//播放器代码
function bno_video_player($post_id,$w,$h,$share,$url,$cpt){
	
	if(!empty($share)){
		$sharemode = $share; //强制限定
	} else {
		$sharemode = get_post_meta($post_id,'video_sharemode',true);
	}
	
	if($cpt=='topic'){
		$file_ID = $post_id;
		$file_url = wp_get_attachment_url( $file_ID );
	} else {
		$file_ID = get_post_meta($post_id,'video_id',true);
		$file_url = get_post_meta($post_id,'video',true);
	}
	if ($sharemode == 'video_upload') {
		$poster = cwg_get_background_image($file_ID,'large');
		$player = '<video class="js-player" playsinline controls width="'.$w.'" height="'.$h.'" poster="'.$poster.'">
						<source src="'.$file_url.'" type="video/mp4">
						<source src="'.$file_url.'" type="video/webm">
				   </video>';
	} elseif($sharemode == 'video_reprint') {
		$uri = get_post_meta($post_id, 'videouri', true);	
		if(!empty($url))$uri =$url; //强制限定
		if (strpos($uri,"youku") > 0 && strpos($uri,"==") > 0):
			preg_match('/http:\/\/.*\/id\_(.+)?\=\=/isU',$uri,$urid);
			$player = '<embed src="http://player.youku.com/player.php/sid/'.$urid[1].'/v.swf" allowFullScreen="true" quality="high" width="100%" height="520" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"youku") > 0 && strpos($uri,"==") < 1 ) :
			preg_match('/http:\/\/.*\/id\_(.+)?\.html/isU',$uri,$urid); 
			$player = '<embed src="http://player.youku.com/player.php/sid/'.$urid[1].'/v.swf" allowFullScreen="true" quality="high" width="100%" height="520" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"qq.com") > 0 && strpos($uri,"?") < 1) :
			$player = '<embed src="http://static.video.qq.com/TPout.swf?vid='.substr($uri,-16,-5).'&auto=0" allowFullScreen="true" quality="high" width="100%" height="520" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"qq.com") > 0 && strpos($uri,"?") > 0 ) :
			$player = '<embed src="http://static.video.qq.com/TPout.swf'.substr($uri,strpos($uri,"?")).'&auto=0" allowFullScreen="true" quality="high" width="100%" height="520" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"yinyuetai") > 0 && strpos($uri,"playlist") > 0) :
			$player = '<embed src="http://player.yinyuetai.com/playlist/player/'.substr(strstr($uri,"playlist"),9).'/v_0.swf" quality="high" width="100%" height="520" align="middle"  allowScriptAccess="sameDomain" allowfullscreen="true" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"yinyuetai") > 0 && strpos($uri,"playlist") < 1) :
			preg_match('/http:\/\/.*\/video\/(.+)?\?f=/isU',$uri,$urid);
			$player = '<embed src="http://player.yinyuetai.com/video/player/'.$urid[1].'/v_0.swf" quality="high" width="100%" height="520" align="middle"  allowScriptAccess="sameDomain" allowfullscreen="true" type="application/x-shockwave-flash"></embed>';
		elseif(strpos($uri,"bilibili.com") > 0 || strpos($uri,"hdslb.com") > 0 ) :
			if(strpos($uri,"av") > 0 && strpos($uri,"?") > 0) $str = substr($uri,strpos($uri,"av")+2,strpos($uri,"?")-strpos($uri,"av")-3);
			if(strpos($uri,"av") > 0 &&  strpos($uri,"?") < 1) {$str = substr($uri,strpos($uri,"av")+2);$str = substr($str,0,strpos($str,"/"));}
			if(strpos($uri,"aid") > 0) $str = substr($uri,strpos($uri,"aid")+3);
			$pg = '';
			if(strpos($uri,"page") > 0) $pg = '&'.substr($uri,strpos($uri,"#")+1);

			$player = '<iframe width="100%" height="359" id="bilibili" src="//player.bilibili.com/player.html?aid='.$str.$pg.'" scrolling="no" border="0" frameborder="no" framespacing="0" allowfullscreen="true"> </iframe>';
		else: 
		endif;	

	} elseif($sharemode == 'wechat_video_reprint') {  
			$uri = get_post_meta($post_id, 'wechat_videouri', true); 
			if(strpos($uri,'qq.com') > 0 && strpos($uri,'html') > 0) { $vid=substr($uri,strpos($uri,'html')-12,11);	} 
			$player = '<iframe frameborder="0" width="600" height="340" src="https://v.qq.com/iframe/player.html?vid='.$vid.'&tiny=1&auto=0" allowfullscreen></iframe>';
	}
	return $player;	
}
?>