<?php

//支持与反对

function ajax_general_init(){
	if(!is_admin()):
		wp_enqueue_style( 'style', get_template_directory_uri().'/style-format.css');
		wp_enqueue_script( 'validation_script', get_template_directory_uri().'/js/validation.js', array( 'jquery' ), '1.1', false); 
		if(isset($_GET['action'])||isset($_GET['new'])||isset($_GET['edit'])){
			wp_enqueue_script( 'tt-static', get_template_directory_uri().'/js/tt-static.js', array( 'jquery' ), '1.1', false); 
		} 
		wp_enqueue_script('bluered_ajax', get_bloginfo('template_directory').'/js/bluered-ajax-scripts.js', array('jquery'), '1.0', true );	
	endif;
    wp_localize_script('bluered_ajax', 'ajax_var', array(
		'url' => admin_url('admin-ajax.php'),
		'nonce' => wp_create_nonce('ajax-nonce')
	));
	
	add_action('wp_ajax_nopriv_more_post_ajax', 'more_post_ajax');
	add_action('wp_ajax_more_post_ajax', 'more_post_ajax');
	add_action('wp_ajax_nopriv_more_post_chunk_ajax', 'more_post_chunk_ajax');
	add_action('wp_ajax_more_post_chunk_ajax', 'more_post_chunk_ajax');	
	add_action('wp_ajax_nopriv_comment_ajax', 'bno_submit_ajax_comment');
	add_action('wp_ajax_comment_ajax', 'bno_submit_ajax_comment');
	add_action('wp_ajax_nopriv_commentlist_ajax', 'bno_ajax_list_comment');
	add_action('wp_ajax_commentlist_ajax', 'bno_ajax_list_comment');
	
	if (is_user_logged_in()) {
		add_action('wp_ajax_post-vote', 'post_vote');
		add_action('wp_ajax_delete-msg', 'bno_delete_msg');
		add_action('wp_ajax_check-pass', 'ajax_user_password_check');
		add_action('wp_ajax_new-pass', 'ajax_user_password_new');
		add_action('wp_ajax_getAlbumVoteLink', 'getAlbumVoteLink');
	}
}

add_action('init', 'ajax_general_init');



function post_vote(){

    $nonce = $_POST['nonce'];
  
    if ( ! wp_verify_nonce( $nonce, 'ajax-nonce' ) )
        die ( 'Busted!');
     
    if(isset($_POST['post_vote']))  {
		
		$vote = $_POST['post_vote'];
		if($vote == 'list-comments') return;
		
		if($vote == 'vote-up') { $event='点赞'; }elseif( $vote == 'vote-down' ){ $event='反对'; } elseif( $vote == 'vote-star' ){ $event='收藏'; } else {$event='关注'; }
		
        $id = '('.get_current_user_id().')';
        $post_id = $_POST['post_id'];
		$album_id = $_POST['album_id'];
 
        if(!is_array($voted_ID))$voted_ID = array();
		if(!is_array($salbum_ID))$salbum_ID = array();

		if($vote !== 'focus') {//非关注用户
			
			$author_id = get_post($post_id)->post_author;		
			$already_message = get_user_meta($author_id,'messages'); //通知
			$album_items = get_post_meta($album_id, 'album_items');	//收藏
			$meta_ID = get_post_meta($post_id, $vote.'_ID');	
			$meta_count = get_post_meta($post_id, $vote.'_count', true);			
		} else {//关注用户
			$author_id = $post_id;
			$meta_ID = get_user_meta($post_id, $vote.'_ID');
			$already_message = get_user_meta($author_id,'messages',true);
			$meta_count = get_user_meta($post_id, $vote.'_count', true);
		}
		if(empty($meta_count)) $meta_count = 0;
		$voted_ID = $meta_ID[0];
		$salbum_ID = $album_items[0];
		$message = $already_message[0];
 
        // User has already voted ?
        if(hasAlreadyVoted($post_id)==false)  {
            $voted_ID[$id] = time();
			if($album_id)$salbum_ID[$post_id] = time();
 
            if($vote !== 'focus') { 
				update_post_meta($post_id, $vote.'_ID', $voted_ID);
				update_post_meta($post_id, $vote.'_count', ++$meta_count);
				if($album_id)update_post_meta($album_id, 'album_items', $salbum_ID);
			} else {
				update_user_meta($post_id, $vote.'_ID', $voted_ID);
				update_user_meta($post_id, $vote.'_count', ++$meta_count);				
			}
			
			//通知作者 同一用户只推送最近操作的消息 早于此的会被覆盖
			$message[$post_id] = get_current_user_id().'-'.$event.'';			
			update_user_meta($author_id, 'messages',$message);
             
            // Display count (ie jQuery return value)
            echo $meta_count;
			
        }  elseif( hasAlreadyVoted($post_id) == 'vote-true' )  {
			
			echo $meta_count-1;
			
			if($vote !== 'focus') {
				
				if($vote == 'vote-star') {
					
					if($album_id){						
						$items = get_post_meta($album_id, 'album_items');
						$checkin = $items[0];
						if(!is_array($checkin))$checkin = array();
						if(in_array($post_id, array_keys($checkin))) {						
							foreach ($salbum_ID as $key =>$value) {
								if ($key == $post_id ) //注意三等号与二等号的区别
									unset($salbum_ID[$key]);
									unset($salbum_ID[$value]);
							}						
						} else {
							$salbum_ID[$post_id] = time();
						}
						update_post_meta($album_id, 'album_items', $salbum_ID);
					}
				
					if(bno_album_include_check($post_id) == 0 ){
						foreach ($voted_ID as $key=>$value) {
						  if ($key === $id )
							unset($voted_ID[$key]);
							unset($voted_ID[$value]);
						} 
						update_post_meta($post_id, $vote.'_count', --$meta_count);
						update_post_meta($post_id, $vote.'_ID',$voted_ID);
					}					
					
				} else {
					
					foreach ($voted_ID as $key=>$value) {
					  if ($key === $id )
						unset($voted_ID[$key]);
						unset($voted_ID[$value]);
					} 
					
					update_post_meta($post_id, $vote.'_count', --$meta_count);
					update_post_meta($post_id, $vote.'_ID',$voted_ID);
					
				}

			} else {
				
				foreach ($voted_ID as $key=>$value) {
				  if ($key === $id )
					unset($voted_ID[$key]);
					unset($voted_ID[$value]);
				} 
				
				update_user_meta($post_id, $vote.'_count', --$meta_count);
				update_user_meta($post_id, $vote.'_ID',$voted_ID);
			}

			//通知作者
			$message[$post_id] = get_current_user_id().'-取消'.$event.'';			
			update_user_meta($author_id, 'messages',$message);
			
			
		} elseif( hasAlreadyVoted($post_id) == 'anti-vote-true' ) {
			
			$types = array('vote-up','vote-down');
			$key = array_search($vote, $types);
			if ($key !== false) array_splice($types, $key, 1);
			$anti_vote = $types[0];
			
			$anti_meta_ID = get_post_meta($post_id, $anti_vote.'_ID');
			$anti_voted_ID = $anti_meta_ID[0];
			
			if(!is_array($anti_voted_ID)) $anti_voted_ID = array();
			$anti_meta_count = get_post_meta($post_id, $anti_vote.'_count', true);
			
			$voted_ID[$id] = time();
            update_post_meta($post_id, $vote.'_ID', $voted_ID);
            update_post_meta($post_id, $vote.'_count', ++$meta_count);
            echo $meta_count;
			
			update_post_meta($post_id, $anti_vote.'_count', --$anti_meta_count);
			
			foreach ($anti_voted_ID as $key=>$value) {
			  if ($key === $id )
				unset($anti_voted_ID[$key]);
				unset($anti_voted_ID[$value]);
			}
			update_post_meta($post_id, $anti_vote.'_ID',$anti_voted_ID);

			//通知作者
			$message[$post_id] = get_current_user_id().'-'.$event.'';			
			update_user_meta($author_id, 'messages',$message);			
			
		}
		if($vote !== 'focus')authorVoteData($post_id);//判断以避免在点关注时计入错误

    }
    exit;
}

function hasAlreadyVoted($post_id) {
	
	$vote = $_POST['post_vote'];
 
	if($vote == 'focus') { 
		$meta_ID = get_user_meta($post_id, $vote.'_ID'); 
	} else {
		$meta_ID = get_post_meta($post_id, $vote.'_ID');		
	}
    $voted_ID = $meta_ID[0];
	
	$types = array('vote-up','vote-down');
	$key = array_search($vote, $types);
	if ($key !== false) array_splice($types, $key, 1);
	$anti_vote = $types[0];
	
	$anti_meta_ID = get_post_meta($post_id, $anti_vote.'_ID');
	$anti_voted_ID = $anti_meta_ID[0];
     
    if(!is_array($voted_ID))
        $voted_ID = array();
	
	if(!is_array($anti_voted_ID))
        $anti_voted_ID = array();
         
    // Retrieve current user IP
    $id = '('.get_current_user_id().')';
    
    // If user has already voted
    if(in_array($id, array_keys($voted_ID)))  { 
		return 'vote-true';  
	} elseif (in_array($id, array_keys($anti_voted_ID))) { 
		if($vote == 'vote-up'||$vote == 'vote-down')return 'anti-vote-true'; 
	} else{
		return false;
	}
}

function authorVoteData($post_id) {//暂且只处理点赞数量
	$author = get_post($post_id)->post_author;
	$args = array(
				'post_type' => array('post','video','case','topicreply'),
				'numberposts' => -1,
				'author' => $author,
				'post_status'=> array ( 'publish' ),
				'meta_query' => array(	array('key' => 'vote-up_count')) 
			); 			
	$sum = 0;			
	$voteups = get_posts($args);						
	foreach($voteups as $vt )
		{
			 if( get_post_meta( $vt->ID,'vote-up_count',true) ){
				$sum += get_post_meta( $vt->ID,'vote-up_count',true);
			 }
		}
	update_user_meta($author, 'vote-up_count',$sum);	
}

function getPostVoteLink($post_id,$vote){//文章相关投票
	
    $themename = 'BlueRed';
    $vote_count = get_post_meta($post_id, $vote.'_count', true);
	
	$arrow = '';
	$ajaxid = 'post-vote';	
	if ( $vote == 'vote-up') { 
		$arrow = file_get_contents(home_url('/assets/svg/thumb-up.svg'));
		$title = '支持';
	} elseif ($vote == 'vote-down') { 
		$arrow = file_get_contents(home_url('/assets/svg/thumb-down.svg'));
		$title = '反对';
	} else { 
		$arrow = file_get_contents(home_url('/assets/svg/star.svg'));
		$title = '收藏';
		$ajaxid = $login = '';
	}
	
	$class = '';
	
	$meta_ID = get_post_meta($post_id, $vote.'_ID');
	$voted_ID = $meta_ID[0];
	
	if(!is_array($voted_ID))$voted_ID = array();
         
    $id = '('.get_current_user_id().')';

    if(in_array($id, array_keys($voted_ID)))  {
        $class = 'voted'; 
     } else {
		$class = 'rdobox';
	 }

	if(empty($vote_count)) $vote_count = 0;

	if (!is_user_logged_in()) {
		$login = 'href="'.home_url('/login').'?path='.home_url(add_query_arg(array())).'"';
		$ajaxid = '';
	}
 
    $output = '<label class="'.$class.'" id="'.$ajaxid.'" for="'.$vote.'">';

	$output .= '<a '.$login.' data-vote_type="'.$vote.'" data-post_id="'.$post_id.'" id="'.$vote.'">
                    <span  title="'.__($title, $themename).'"class="click-icon">'.$arrow.'</span>
                </a>';
	
    $output .= '<span class="count">'.$vote_count.'</span></label>';
     
    return $output;
}

function getAlbumVoteLink(){//收藏到专辑
	
	if (!is_user_logged_in()) return;
	
	$vote = 'vote-star';
	$post_id = $_POST['post_id'];
	$album_tt = $_POST['album_title'];
	if(empty($post_id)) $post_id = get_the_ID();
	
	if( !empty($album_tt)&&$album_tt !== 'undefined' ) {
		$nonce = $_POST['nonce'];
		if ( ! wp_verify_nonce( $nonce, 'ajax-nonce' ) )die ( 'Busted!');
		
		$album_id = wp_insert_post(array('post_title'=>$album_tt,'post_type'=>'album','post_status'=>'publish','post_name'=>$name.'_'.$album_id));
		$title = mb_strimwidth(strip_tags(Pinyin::getPinyin($album_tt)), 0, 60,"");
		$name = substr(md5($title), 0, 15).'_'.$album_id;
		wp_update_post(array('ID' => $album_id, 'post_name' => $name));
		update_post_meta($album_id,'album_scraper','manual');
		$salbum_ID[$post_id] = time();
		update_post_meta($album_id, 'album_items', $salbum_ID);
	}	
	
	$class = '';
	echo '<div id="albumboxContent">
		  <div class="albumBoxHeader">	
			<h3>选择或新建收藏夹</h3>
			<span id="buttonClose" class="close-btn right">'.file_get_contents(home_url('/assets/svg/error.svg')).'</span>			
		  </div>';
	echo '<ul class="album-list">';
	$cur_user = get_current_user_id();
	$albums = get_posts(array('post_type'=>'album','showposts' => 24,'author'=>$cur_user,'meta_query'=>array(array('key'=>'album_scraper','value'=>'manual'))));
	foreach($albums as $album) {
		
		$meta_ID = get_post_meta($album->ID, 'album_items');
		$voted_ID = $meta_ID[0];
		if(!is_array($voted_ID))$voted_ID = array();

		if(in_array($post_id, array_keys($voted_ID)))  {
			$class = 'voted'; 
			$iconL = file_get_contents(home_url('/assets/svg/hearts.svg'));
			$iconR = '<i class="fa fa-minus-circle right" aria-hidden="true"></i>';
			$words = '取消收藏#'.$album->post_title;
		 } else {
			$class = 'rdobox';
			$iconL = file_get_contents(home_url('/assets/svg/hearts.svg'));
			$iconR = '<i class="fa fa-plus-circle right" aria-hidden="true"></i>';
			$words = '收藏到#'.$album->post_title;
		 }
		
		echo '<li class="album-'.$album->ID.'"><label class="'.$class.'" id="post-vote">';
		echo '<a href="#" data-vote_type="'.$vote.'" data-post_id="'.$post_id.'" data-album_id="'.$album->ID.'" title="'.$words.'">
					'.$iconL.'<span class="click-icon">&nbsp;'.$album->post_title.'</span>'.$iconR.'
					</a>';
		echo '</label></li>';
	}
	
	echo '</ul></div>';
	echo '<div class="create-new box-inner txt-center">
				<div title="新建收藏夹" id="albumNew">
					<span class="click-icon">新建收藏夹</span>
				</div>
				<div id="albumNew-box" style="display:none;">	
					<input type="text" name="album_title" id="album_title" value="" autocomplete="off" placeholder="输入新收藏夹名称并添加……">
						<span class="albumremove-btn">'.file_get_contents(home_url('/assets/svg/error.svg')).'</span>
						<span class="albumnew-btn"><a data-post_id="'.$post_id.'" title="添加到收藏夹" id="albumSubmit">'.file_get_contents(home_url('/assets/svg/success.svg')).'</a></span>
					</span>
				</div>
		</div><div class="clear"></div>';

}

function bno_album_include_check($post_id){//检查所有专辑是否包含
	
	if (!is_user_logged_in()) return;
	
	$cur_user = get_current_user_id();
	$albums = get_posts(array('post_type'=>'album','author'=>$cur_user,'meta_query'=>array(array('key'=>'album_scraper','value'=>'manual'))));
	foreach($albums as $album) {
		
		$meta_ID = get_post_meta($album->ID, 'album_items');
		$voted_ID = $meta_ID[0];
		if(!is_array($voted_ID))$voted_ID = array();
		if(in_array($post_id, array_keys($voted_ID)))  { $sum += 1;} else {$sum += 0;}
	}
	return $sum;
}

function getAuthorStarLink($user_id,$event){//关注用户相关
	
    $themename = 'BlueRed';
    $usr_event_count = get_user_meta($user_id, $event.'_count', true);
	
	$arrow = '';	
	if ( $event == 'focus') { 
		$arrow = file_get_contents(home_url('/assets/svg/plus.svg'));
		$title = $span = '关注'; 
	}
	
	$class = '';	
	if(empty($usr_event_count)) $usr_event_count = 0;
	
	$meta_ID = get_user_meta($user_id, $event.'_ID');
	$event_ID = $meta_ID[0];
	
	    if(!is_array($event_ID))$event_ID = array();
         
    $id = '('.get_current_user_id().')';

    if(in_array($id, array_keys($event_ID)))  {
        $class = 'voted';
		$usr_event_count = '已'.$span;
     } else {
		$class = 'rdobox';
		$usr_event_count = $span;
	 }
	 $login ='';
	 $ajaxid = 'post-vote';
	 if (!is_user_logged_in()) {
		$login = 'href="'.home_url('/login').'?path='.home_url(add_query_arg(array())).'"';
		$ajaxid = '';
	}
 
    $output = '<label class="'.$class.'" id="'.$ajaxid.'" for="'.$event.'">';
	$output .= '<a '.$login.' data-vote_type="'.$event.'" data-post_id="'.$user_id.'">
                    <span title="'.__($title, $themename).'"class="click-icon">'.$arrow.'</span>
				</a>';	
    $output .= '<span class="count">'.$usr_event_count.'</span></label>';
     
    return $output;
}

// 一般用户消息推送

	add_action('publish_post','bno_user_push_messages');//注意钩子名称
	add_action('publish_topicreply','bno_user_push_messages');
	add_action('publish_video','bno_user_push_messages');	
	
	function bno_user_push_messages($post_id,$status){
		
		//message push			
		$user_id = get_post($post_id)->post_author;
		
		$cur_id = get_current_user_id();
		
		$already_message = get_user_meta($user_id,'messages');		
		
		$message = $already_message[0];
		
	if(!is_array($message))$message = array();
		
		$message[$post_id] = $cur_id.'-审核通过';
						
		update_user_meta($user_id,'messages',$message);

	}
	
	add_action('comment_post', 'bno_comment_approved', 10, 2 );
	
	function bno_comment_approved($comment_ID, $comment_approved) {
		
		if( 1 === $comment_approved ){

			$comment = get_comment($comment_ID);
			
			$post_id = $comment-> comment_post_ID;
			
			$parent_id = $comment->comment_parent ? $comment->comment_parent : '';
			
			$parent_comment_author = get_comment($parent_id)->user_id;
				
			$user_id = get_post($post_id)->post_author;
			
			$cur_id = get_current_user_id();
			
			$already_message = get_user_meta($user_id,'comment-messages');		
			
			$message = $already_message[0];
			
		if(!is_array($message))$message = array();
		
			$message[$comment_ID] = $cur_id.'-'.$post_id;		
		
		if($user_id !== $cur_id) {			
			update_user_meta($user_id,'comment-messages',$message);
		}
			
		if(!empty($parent_comment_author) && $cur_id !== $parent_comment_author && $user_id !== $cur_id) {
			update_user_meta($parent_comment_author,'comment-messages',$message);	

			}

		}

	}	
	
	function bno_delete_msg(){

		$nonce = $_POST['nonce'];
	  
		if ( ! wp_verify_nonce( $nonce, 'ajax-nonce' ) )
			die ( 'Busted!');
		 
		if(isset($_POST['post_vote']))  {
			
			$post_id = $_POST['post_id'];
			$event = $_POST['event'];
			$user_id = get_current_user_id();
			
			$meta_types = array ('messages','comment-messages');
			
			foreach( $meta_types as $meta_type) {

				$messages = get_user_meta($user_id, $meta_type);
				$msg = $messages[0];			
						
						foreach ($msg as $k => $v) {
							
						  if ($k === intval($post_id)) {
							  
							unset($msg[$k]);
							unset($msg[$v]);						  
							  
						  }
						  
						}
						
				update_user_meta($user_id, $meta_type,$msg);	
			} 
		}	
		exit;
	}
	
	
	function getMessageBar($post_id,$vote,$event){
		
		$themename = 'BlueRed';
		$vote_count = get_post_meta($post_id, $vote.'_count', true);
		
		$arrow = 'remove';	

		 $login ='';
		 if (!is_user_logged_in()) $login = 'show_login';
	 
		$output = '<label class="left" id="post-vote">';

		$output .= '<a href="#" data-vote_type="'.$vote.'" data-event_type="'.$event.'" data-post_id="'.$post_id.'" id="'.$login.'">
						<span  title="'.__('删除', $themename).'"class="qtip like"><i class="icon-'.$arrow.'"></i></span></a>';
		
		$output .= '</label>';
		 
		return $output;
	}	

	function ajax_user_password_check(){
		check_ajax_referer( 'ajax-nonce', 'security' );//验证nonce
		$user_id = get_current_user_id();
		$user_name = get_userdata($user_id)->user_login;
		$check = wp_authenticate_username_password( $user_id, $user_name, $_POST['password'] );
		if($_POST['do']=="check"){			
			if ( is_wp_error($check) )
				echo json_encode(array('loggedin'=>false, 'message'=>__('输入错误！')));
		 } else {
			if ( is_wp_error($check)||empty($_POST['password2'])|| ($_POST['password2']!==$_POST['password1']) || strlen($_POST['password2'])<6){
				echo json_encode(array('loggedin'=>false, 'message'=>__('输入错误！')));
			} else {
				wp_update_user(	array(  'ID' => $user_id,'user_pass'  => $_POST['password2']) );
			}
		} 
	}
	
	function bno_submit_ajax_comment(){

		$comment = wp_handle_comment_submission( wp_unslash( $_POST ) );
		if ( is_wp_error( $comment ) ) {
			$error_data = intval( $comment->get_error_data() );
			if ( ! empty( $error_data ) ) {
				wp_die( '<p>' . $comment->get_error_message() . '</p>', __( 'Comment Submission Failure' ), array( 'response' => $error_data, 'back_link' => true ) );
			} else {
				wp_die( 'Unknown error' );
			}
		}
	 
		/*
		 * Set Cookies
		 */
		$user = wp_get_current_user();
		do_action('set_comment_cookies', $comment, $user);
	 
		/*
		 * If you do not like this loop, pass the comment depth from JavaScript code
		 */
		$comment_depth = 1;
		$comment_parent = $comment->comment_parent;
		while( $comment_parent ){
			$comment_depth++;
			$parent_comment = get_comment( $comment_parent );
			$comment_parent = $parent_comment->comment_parent;
		}
	 
		/*
		 * Set the globals, so our comment functions below will work correctly
		 */
		$GLOBALS['comment'] = $comment;
		$GLOBALS['comment_depth'] = $comment_depth;
	 
		/*
		 * Here is the comment template, you can configure it for your website
		 * or you can try to find a ready function in your theme files
		 */
		$comment_html = '<li ' . comment_class('wow flipInX', null, null, false ) . ' id="comment-' . get_comment_ID() . '">
			<article class="comment-body" id="div-comment-' . get_comment_ID() . '">
				<footer class="comment-meta">
					<div class="comment-author vcard">
						' . get_avatar( $comment, 32 ) . '
						<span class="fn">' . get_comment_author_link() . '</span>
					</div>
					<div class="comment-metadata">
						<a href="' . esc_url( get_comment_link( $comment->comment_ID ) ) . '">' . sprintf('%1$s %2$s', get_comment_date(),  get_comment_time() ) . '</a>';
	 
						if( $edit_link = get_edit_comment_link() )
							$comment_html .= '<span class="comment-edit-link"><a class="comment-edit-link" href="' . $edit_link . '">(编辑)</a></span>';
	 
					$comment_html .= '</div>';
					if ( $comment->comment_approved == '0' )
						$comment_html .= '<p class="comment-awaiting-moderation">您的评论将会在审核通过后显示.</p>';
	 
				$comment_html .= '</footer>
				<div class="comment-content">' . apply_filters( 'comment_text', get_comment_text( $comment ), $comment ) . '</div>
			</article>
		</li>';
		echo $comment_html;
	 
		die();
	 
	}
	
	function bno_ajax_list_comment(){ 
		get_template_part( 'comments', 'topic' );
	
	}	

	//ajax 加载更多文章-首页
	function more_post_ajax(){
		
		$page = (isset($_POST['pageNumber'])) ? $_POST['pageNumber'] : 0;
		$type = $_POST['type']; 
		$cpts = array('post','topicreply','video');
		$parent = $_POST['parent']; 
		$excid = $_POST['excid'];
		
		header('Content-Type: text/html');
		
 		if($parent!== 0 && ($type=='topic'||$type=='topicreply')){			
			$args = array(
				'suppress_filters' => true,
				'post_type' => $cpts,
				'posts_per_page' => 24,
				'paged'=> $page,
				'post_parent' => $parent,
				'post_status' => 'publish',
				'meta_key'=> 'vote-up_count',
				'orderby' => 'meta_value_num',
				'order' => 'DESC',
			);
		} elseif( $type == 'video'|| $type == 'archive-video'){
			$args = array(
				'suppress_filters' => true,
				'post_type' => 'video',
				'posts_per_page' => 24,
				'paged'=> $page,
				'post_status' => 'publish',
				'exclude' => array($excid),
			);
		} elseif( $type == 'author'){
			$args = array(
				'suppress_filters' => true,
				'post_type' => $parent,
				'posts_per_page' => 24,
				'author' => $excid,
				'paged'=> $page,
				'post_status' => 'publish',
			);
		} elseif( $type == 'archive-post'){
			$args = array(
				'suppress_filters' => true,
				'post_type' => 'post',
				'cat' => $parent,
				'posts_per_page' => 24,
				'paged'=> $page,
				'post_status' => 'publish',
			);
			
		} elseif( $type == 'all'){
			$args = array(
				'suppress_filters' => true,
				'post_type' => array('post','video','topic'),
				'posts_per_page' => 24,
				'paged'=> $page,
				'post_status' => 'publish',
				'exclude' => array($excid),
			);
		} else { 
			$args = array(
				'suppress_filters' => true,
				'post_type' => $type,
				'paged'=> $page,
				'post_status' => 'publish',
			);			
		}

		$loop = new WP_Query($args);
			
		if ($loop -> have_posts()) :  while ($loop -> have_posts()) : $loop -> the_post();
			$cpt = get_post($post_id)->post_type;
			if($type=='all') {
				
				if( $cpt == 'topic'){
					get_template_part( 'content', 'home-topic' );
				} elseif($cpt == 'video'){
					get_template_part( 'content', 'home-video' );
				} else	{
					get_template_part( 'content', 'home-post' );
				}

			} elseif($type=='video') {
				
				get_template_part( 'content', 'home-video' );
				
			} elseif($type=='topic') {
				
				get_template_part( 'content', 'home-topic' );
				
			} elseif($type=='author') {
				
				get_template_part( 'content', 'author-post' );
				
			} elseif($type=='photo' || $type=='sp') {
				
				get_template_part( 'content', 'photo' );				
				
			} else {
				
				get_template_part( 'content', 'home-share' );
				
			}

		endwhile;	endif;	
		
		wp_reset_postdata();
	}
	
//lister显示位置设置
	add_action('publish_lister','lister_place_change');
	function lister_place_change($post_id) {
		$placeset = get_post_meta($post_id,'lister_place',true);
		if($placeset=='homeSearch') update_option( 'HomeSearchBg', $post_id);
		if($placeset=='CaseArchiveBg') update_option( 'CaseArchiveBg', $post_id);
		if($placeset=='homeTopAd') update_option( 'HomeTopAd', $post_id);
		if($placeset=='homeMidAd') update_option( 'HomeMidAd', $post_id);
		if($placeset=='sideAd') update_option( 'SideAd', $post_id);
		if($placeset=='MobileSlider') update_option( 'MobileSlider', $post_id);
	}