<?php

add_action( 'cmb2_admin_init', 'cmb2_metaboxes' );

/* Define the metabox and field configurations */
function cmb2_metaboxes() {	

//album
	$cmb = new_cmb2_box( array(
        'id'            => 'album_metabox',
        'title'         => __( '收录设置', 'cmb2' ),
        'object_types'  => array( 'album' ), // Post type
        'context'       => 'normal',
        'priority'      => 'low',
        'show_names'    => true, 
    ) );	
	
    $cmb->add_field( array(
        'name'       => __( '收录方式', 'cmb2' ),
        'id'         => 'album_scraper',
		'type'   	 => 'radio_inline',
		'options' => array(
			'manual' => '手动',
			'tag' => '按标签',
		),
		'default' => 'manual',
	) );
	
//video

	$cmb = new_cmb2_box( array(
        'id'            => 'video_metabox',
        'title'         => __( '视频设置', 'cmb2' ),
        'object_types'  => array( 'video' ), // Post type
        'context'       => 'normal',
        'priority'      => 'low',
        'show_names'    => true, 
    ) );	
	
    $cmb->add_field( array(
        'name'       => __( '视频字幕', 'cmb2' ),
        'id'         => 'video-sub',
		'type'    => 'file',
		'query_args' => array(
			//'type' => 'text/vtt', 
		),
	) );	
	
//lister	
	$cmb = new_cmb2_box( array(
        'id'            => 'slider_metabox',
        'title'         => __( '在哪里显示？', 'cmb2' ),
        'object_types'  => array( 'lister' ), // Post type
        'context'       => 'side',
        'priority'      => 'low',
        'show_names'    => true, 
    ) );	
	
    $cmb->add_field( array(
        'id'         => 'lister_place',
		'type'             => 'select',
		'default'          => 'none',
		'options'          => array(
			'homeSearch' => __( '首页搜索模块背景', 'cmb2' ),
			'CaseArchiveBg' => __( '案例顶部模块背景', 'cmb2' ),
			'homeTopAd' => __( '首页第一行广告位', 'cmb2' ),
			'homeMidAd' => __( '首页第二行广告位', 'cmb2' ),	
			'sideAd' => __( '全局边栏广告位', 'cmb2' ),	
			'MobileSlider' => __( '移动端Slider', 'cmb2' ),	
			'none'   => __( '不在任何位置显示', 'cmb2' ),									
		),
	) );
	
    $cmb->add_field( array(
        'id'         => 'lister_time_change',
		'type'             => 'hidden',
		'attributes' => array(
			'value' => time(), 
		),
	) );

//service
	
	$cmb = new_cmb2_box( array(
        'id'            => 'sve_metabox',
        'title'         => __( '服务页选项和内容设置', 'cmb2' ),
        'object_types'  => array( 'service' ), // Post type
        'context'       => 'normal',
        'priority'      => 'low',
		'cmb_styles'    => false,
        'show_names'    => true, 
    ) );	
	
    $cmb->add_field( array(
		'name' => '顶部幻灯',
        'id'         => 'sve_brand_slider',
		'type'             => 'text_number',
		'attributes' => array(
			'placeholder' => '输入lister ID（ID必须为阿拉伯数字类型）',
		),
	) );	
    $cmb->add_field( array(
		'name' => '灯箱样式',
        'id'         => 'sve_brand_slider_mode',
		'type'             => 'select',
		'show_option_none' => true,
		'default'          => 'mF_kdui',
		'options'          => array(
			'mF_fancy' => __( 'mF_fancy', 'cmb2' ),
			'mF_dleung'   => __( 'mF_dleung', 'cmb2' ),
			'mF_kdui'     => __( 'mF_kdui', 'cmb2' ),
		),
	) );
    $cmb->add_field( array(
		'name' => '案例分类',
        'id'         => 'sve_case_category',
		'taxonomy'       => 'gen-types',
		'type'             => 'taxonomy_multicheck_inline',
	) );
	
	$group_field_id = $cmb->add_field( array(
		'id'          => 'sve_repeat_group',
		'type'        => 'group',
		'options'     => array(
			'group_title'   => __( 'Entry {#}', 'cmb2' ), 
			'add_button'    => __( 'Add Another Entry', 'cmb2' ),
			'remove_button' => __( 'Remove Entry', 'cmb2' ),
			'sortable'      => true, // beta
			'closed'     => true,
		),
	) );

	$cmb->add_group_field( $group_field_id, array(
		'name' => '条目标题',
		'id'   => 'sve_item_title',
		'type' => 'text',
		'attributes'  => array(
			'placeholder' => '输入条目主标题（将以大号字体单行显示）',
			'size'        => 25,
			'required'    => 'required',
		),
	) );

	$cmb->add_group_field( $group_field_id, array(
		'name' => '内容描述',
		'id'   => 'sve_item_description',
		'type' => 'wysiwyg',
		'options' => array(
			'wpautop' => true, 
			'media_buttons' => false, 
			'textarea_name' => $editor_id, // set the textarea name to something different, square brackets [] can be used here
			'textarea_rows' => get_option('default_post_edit_rows', 10), // rows="..."
			'tabindex' => '',
			'editor_css' => '', // intended for extra styles for both visual and HTML editors buttons, needs to include the `<style>` tags, can use "scoped".
			'editor_class' => '', // add extra class(es) to the editor textarea
			'teeny' => true, // output the minimal editor config used in Press This
			'dfw' => false, // replace the default fullscreen with DFW (needs specific css)
			'tinymce' => true, // load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' => true // load Quicktags, can be used to pass settings directly to Quicktags using an array()
		),
	) );

	$cmb->add_group_field( $group_field_id, array(
		'name' => '文字区宽',
		'id'   => 'sve_item_desc_w',
		'type' => 'text_number',
		'attributes' => array(
			'placeholder' => '输入阿拉伯数字',
		),
		'after_field' => 'px',
	) );	
	
	$cmb->add_group_field( $group_field_id, array(
		'name' => '区块背景',
		'id'   => 'sve_item_desc_bg',
		'type'    => 'colorpicker',
		'default' => '#f7f7f7',
	) );	

	$cmb->add_group_field( $group_field_id, array(
		'name' => '选择图片',
		'id'   => 'sve_item_image',
		'type' => 'file',
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),
	) );
	
	$group_field_id2 = $cmb->add_field( array(
		'id'          => 'related_sve_repeat_group',
		'type'        => 'group',
		'options'     => array(
			'group_title'   => __( '关联服务{#}', 'cmb2' ), 
			'add_button'    => __( 'Add Another Entry', 'cmb2' ),
			'remove_button' => __( 'Remove Entry', 'cmb2' ),
			'sortable'      => true, // beta
			'closed'     => true,
		),
	) );
	
    $cmb->add_field( array(
		'name' => '启用移动端专用页面',
        'id'         => 'sve_mobile_open',
		'type' => 'checkbox',
		'after_field' => '启用后PC端条目将不在移动端显示',
	) );	

	$page_group_field_id = $cmb->add_field( array(
		'id'          => 'sve_mobile_repeat_group',
		'type'        => 'group',
		'options'     => array(
			'group_title'   => __( '行{#}', 'cmb2' ), 
			'add_button'    => __( 'Add Another Entry', 'cmb2' ),
			'remove_button' => __( 'Remove Entry', 'cmb2' ),
			'sortable'      => true, // beta
			'closed'     => true,
		),
	) );

	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '条目标题',
		'id'   => 'sve_mobile_item_title',
		'type' => 'text',
		'attributes'  => array(
			'placeholder' => '输入行标题（将以大号字体单行显示）',
			'size'        => 25,
		),
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '内容描述',
		'id'   => 'sve_mobile_item_description',
		'type' => 'wysiwyg',
		'options' => array(
			'wpautop' => true, 
			'media_buttons' => false, 
			'textarea_name' => $editor_id, // set the textarea name to something different, square brackets [] can be used here
			'textarea_rows' => get_option('default_post_edit_rows', 10), // rows="..."
			'tabindex' => '',
			'editor_css' => '', // intended for extra styles for both visual and HTML editors buttons, needs to include the `<style>` tags, can use "scoped".
			'editor_class' => '', // add extra class(es) to the editor textarea
			'teeny' => true, // output the minimal editor config used in Press This
			'dfw' => false, // replace the default fullscreen with DFW (needs specific css)
			'tinymce' => true, // load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' => true // load Quicktags, can be used to pass settings directly to Quicktags using an array()
		),
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '行列高度',
		'id'   => 'sve_mobile_item_h',
		'type' => 'text_number',
		'attributes' => array(
			'placeholder' => '输入阿拉伯数字',
		),
		'after_field' => 'px',
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '背景颜色',
		'id'   => 'sve_mobile_item_bg_color',
		'type'    => 'colorpicker',
		'default' => '#f7f7f7',
	) );		
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '行列背景',
		'id'   => 'sve_mobile_item_image',
		'type' => 'file',
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),
	) );		

	$cmb->add_group_field( $group_field_id2, array(
		'name' => '服务名称',
		'id'   => 'related_sve_item_title',
		'type' => 'text',
		'attributes'  => array(
			'placeholder' => '输入服务名称标题（留空将显示原服务名称）',
			'size'        => 25,
			'required'    => 'required',
		),
	) );
	
	$cmb->add_group_field( $group_field_id2, array(
		'name' => '服务ID',
		'id'   => 'related_sve_item_id',
		'type' => 'text_number',
		'attributes' => array(
			'placeholder' => '输入阿拉伯数字',
		),
	) );	

    $cmb->add_field( array(
		'name' => 'RedBook URL',
        'id'         => 'sve_redbook_url',
		'type'             => 'text_url',
		'attributes' => array(
			'placeholder' => '输入可供下载的RedBook连接地址，没有请留空',
		),
	) );
// page

	$cmb = new_cmb2_box( array(
        'id'            => 'page_metabox',
        'title'         => __( 'PAGE页面设置', 'cmb2' ),
        'object_types'  => array( 'page' ), // Post type
        'context'       => 'normal',
        'priority'      => 'low',
		'cmb_styles'    => false,
        'show_names'    => true, 
    ) );	
	
    $cmb->add_field( array(
		'name' => '启用全宽度',
        'id'         => 'page_full_wide',
		'type' => 'checkbox',
		'after_field' => '需将页面模板设置为全宽度才会显示',
	) );	

	$page_group_field_id = $cmb->add_field( array(
		'id'          => 'page_repeat_group',
		'type'        => 'group',
		'options'     => array(
			'group_title'   => __( '行{#}', 'cmb2' ), 
			'add_button'    => __( 'Add Another Entry', 'cmb2' ),
			'remove_button' => __( 'Remove Entry', 'cmb2' ),
			'sortable'      => true, // beta
			'closed'     => true,
		),
	) );

	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '条目标题',
		'id'   => 'page_item_title',
		'type' => 'text',
		'attributes'  => array(
			'placeholder' => '输入行标题（将以大号字体单行显示）',
			'size'        => 25,
		),
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '内容描述',
		'id'   => 'page_item_description',
		'type' => 'wysiwyg',
		'options' => array(
			'wpautop' => true, 
			'media_buttons' => false, 
			'textarea_name' => $editor_id, // set the textarea name to something different, square brackets [] can be used here
			'textarea_rows' => get_option('default_post_edit_rows', 10), // rows="..."
			'tabindex' => '',
			'editor_css' => '', // intended for extra styles for both visual and HTML editors buttons, needs to include the `<style>` tags, can use "scoped".
			'editor_class' => '', // add extra class(es) to the editor textarea
			'teeny' => true, // output the minimal editor config used in Press This
			'dfw' => false, // replace the default fullscreen with DFW (needs specific css)
			'tinymce' => true, // load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' => true // load Quicktags, can be used to pass settings directly to Quicktags using an array()
		),
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '行列高度',
		'id'   => 'page_item_h',
		'type' => 'text_number',
		'attributes' => array(
			'placeholder' => '输入阿拉伯数字',
		),
		'after_field' => 'px',
	) );
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '背景颜色',
		'id'   => 'page_item_bg_color',
		'type'    => 'colorpicker',
		'default' => '#f7f7f7',
	) );		
	$cmb->add_group_field( $page_group_field_id, array(
		'name' => '行列背景',
		'id'   => 'page_item_image',
		'type' => 'file',
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),
	) );	

}

add_action( 'cmb2_init', 'cmb2_user_front_metaboxes' );

function cmb2_user_front_metaboxes() {	

	function cmb_only_show_for_front_end(){
		if(is_admin()) return ;
	}

    // 用户字段	
	$cmb_user = new_cmb2_box( array(
		'id'               => 'front-user-edit',
		'object_types'     => array( 'user' ), 
		'show_names'       => true,
		'cmb_styles' => false,
		'show_in_rest' => WP_REST_Server::READABLE,
		'save_fields'  => false,
		'show_on_cb' => 'cmb_only_show_for_front_end'
	) );
	
	$cmb_user->add_field( array(
		'name'    => __( '账号', 'cmb2' ),
		'id'      => 'user-account',
		'type'    => 'text_medium',
		'after_field' => '<span style="padding-left:12px;">不可更改<span>',
		'attributes' => array(
			'autocomplete' => 'off', 
			'placeholder'=>wp_get_current_user()->user_login,
			'disabled' => 'disabled',
		),			
	) );	
	
	$cmb_user->add_field( array(
		'name'    => __( '电子邮件', 'cmb2' ),
		'id'      => 'usermail',
		'type'    => 'text_email',
		'after_field' => '<span style="padding-left:12px;">不会被公开<span>',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'value'=>wp_get_current_user()->user_email,
			'placeholder'=>wp_get_current_user()->user_email,
		),			
	) );
	
	$cmb_user->add_field( array(
		'name'    => __( '昵称', 'cmb2' ),
		'id'      => 'nickname',
		'type'    => 'text_medium',
		'after_field' => '<span style="padding-left:12px;">最多8个汉字<span>',		
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
		),			
	) );	
	
 	$cmb_user->add_field( array(
		'name'    => __( '修改密码', 'cmb2' ),
		'id'      => 'password2',
		'type'    => 'password_change',		
	) ); 
	
	//城市选择
	$cmb_user->add_field( array( 
		'name'    => __( '城市', 'cmb2' ),
		'id'   => 'city',
		'type' => 'text',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'readonly'=>'readonly',
			'placeholder'=>'选择您目前所在的城市……',
			'readonly'=>"readonly"
		),		
	) );	
	
	$cmb_user->add_field( array(
		'name'    => __( '我的签名', 'cmb2' ),
		'id'      => 'myslug',
		'type'    => 'text',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>__( '请用一句话写自己(不超过12字)', 'cmb2' ),
		),		
	) );

	$cmb_user->add_field( array(
		'name'    => __( '上传头像', 'cmb2' ),
		'id'      => 'avatar',
		'type'    => 'file',
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),		
	) );	

	$cmb_user->add_field( array(
		'name'    => __( '自我介绍', 'cmb2' ),
		'id'      => 'description',
		'type'    => 'textarea',
		'attributes' => array(
			'autocomplete' => 'off', 
			'placeholder'=>__( '请用简要介绍您的个人情况', 'cmb2' ),
			'rows' => 3, 
		),		
	) );
	
 	$cmb_user->add_field( array(
		'id'      => 'fake-user-field',
		'type'    => 'user_edit_script',
	) ); 
}

add_action( 'cmb2_init', 'cmb2_user_register_metaboxes' );

function cmb2_user_register_metaboxes() {	

	function cmb_only_show_page_register(){
		if(!is_page('register')) return ;
	}

    // 用户字段	
	$cmb_user = new_cmb2_box( array(
		'id'               => 'user-register',
		'object_types'     => array( 'user' ), 
		'show_names'       => true,
		'cmb_styles' => false,
		'save_fields'  => false,
		'show_on_cb' => 'cmb_only_show_page_register'
	) );
	
	$cmb_user->add_field( array(
		'name'    => __( '用户名', 'cmb2' ),
		'id'      => 'user_login',
		'type'    => 'text_medium',	
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>__( '用作登陆账号，12个字符以内', 'cmb2' ),
		),			
	) );	
	
	$cmb_user->add_field( array(
		'name'    => __( '电子邮箱', 'cmb2' ),
		'id'      => 'usermail',
		'type'    => 'text_email',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>__( '填写常用电子邮件', 'cmb2' ),
		),			
	) );		

/* 	$cmb_user->add_field( array(
		'name'    => __( '输入手机号码', 'cmb2' ),
		'id'      => 'userphone',
		'type'    => 'text_phone',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>__( '手机号码将作为您的登录账号', 'cmb2' ),		
			'onkeypress'   => 'number()',
 			'onkeyup'   =>  'filterInput()',
			'onchange'   =>  'filterInput()',
			'onbeforepaste'   =>  'filterPaste()', 
			'onpaste'   =>  'return false',
			'style'   =>  'ime-mode: disabled',			
			'maxlength' => '11',
			'autocomplete' => 'off', 
		),			
	) ); */
 	$cmb_user->add_field( array(
		'name'    => __( '登录密码', 'cmb2' ),
		'id'      => 'password2',
		'type'    => 'password_regist',		
	) ); 

 	$cmb_user->add_field( array(
		'id'      => 'fake-user-field',
		'type'    => 'user_register_script',
	) );	
}

function user_frontend_cmb2_get() {

	$metabox_id = 'front-user-edit';
	
	$object_id  = wp_get_current_user()->ID;		

	return cmb2_get_metabox( $metabox_id, $object_id );
}


function chumi_handle_frontend_user_edit() {
	
	if (!is_user_logged_in()) return;

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}

	$cmb = user_frontend_cmb2_get();

	$user_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['usermail'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '电子邮件不能为空' ) ) );
	}

	if ( empty( $_POST['nickname'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写昵称' ) ) );
	}	

	if ( empty( $_POST['myslug'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写个人签名' ) ) );
	}	

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$user = wp_get_current_user();
	$user_id = $user->ID;
	do_action('register_form');
	// Set our post data arguments
	$user_data['usermail']   = $sanitized_values['usermail'];
	unset( $sanitized_values['usermail'] );
	$user_data['nickname'] = $sanitized_values['nickname'];
	unset( $sanitized_values['nickname'] );	

	wp_update_user(
		array(  'ID' => $user_id,
				'user_email'  => $user_data['usermail'],
				'display_name' => $user_data['nickname'],
				'nickname' => $user_data['nickname'],	
				'first_name' => $user_data['nickname'],	
			) 
		);

	if ( is_wp_error( $user_id ) ) {
		return $cmb->prop( 'submission_error', $user_id);
	}	
	
	update_user_meta( $user_id, 'avatar', $sanitized_values['avatar'] );
	update_user_meta( $user_id, 'city', $sanitized_values['city'] );
	update_user_meta( $user_id, 'myslug', $sanitized_values['myslug'] );
	update_user_meta( $user_id, 'avatar_id', $sanitized_values['avatar_id'] );
	update_user_meta( $user_id, 'description', $sanitized_values['description'] );
	
	delete_unused_user_profile_attachment($user_id,get_the_ID());
	
	wp_redirect(home_url('/user/account'));	
	
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_user_edit' );  

function delete_unused_user_profile_attachment($user_id,$post_id){
	
	if('page' !== get_post($post_id)->post_type ) return;
	//后台存入的两个字段记录了id
	$avatar = get_user_meta($user_id,'avatar_id',true);
	$bg = get_user_meta($user_id,'bg-image_id',true);

	$args = array(
		'post_type' => 'attachment',
		'author' => $user_id,
		'post_parent' => $post_id,
		'exclude' => array($avatar,$bg),
	);	
	
	$user_files = get_posts($args);
	
	if($user_files) {
		foreach($user_files as $file){			
			wp_delete_attachment( $file->ID );			
		}
	}	
}

function chumi_handle_user_register() {
	
	if (is_user_logged_in()) return;

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	
	$metabox_id = 'user-register';

	$object_id = 'fake_userid';

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$user_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	$sanitized_values = $cmb->get_sanitized_values( $_POST );
	do_action('register_form');
	
	
	$user_data['usermail'] = $sanitized_values['usermail'];
	unset( $sanitized_values['usermail'] );
	$user_data['user_login'] = $sanitized_values['user_login'];
	unset( $sanitized_values['user_login'] );	
	$user_data['password'] = $sanitized_values['password2'];
	unset( $sanitized_values['password2'] );
	
	$nickname = getRandomString(5);
	$nicename = substr(md5(time()), 0, 8).'='.$nickname;

	$user_register = wp_insert_user(
		array(  'user_login'  => $user_data['user_login'],
				'user_pass' => $user_data['password'],
				'display_name' => $nickname,
				'nickname' => $nickname,	
				'first_name' => $nickname,
				'user_nicename'=> $nicename,
				'user_email'=> $user_data['usermail'],
			) 
		);
		
 	if ( is_wp_error($user_register) ){	
	
		$error  = $user_register->get_error_codes()	;
		
		if(in_array('empty_user_login', $error))wp_redirect(home_url('/register?reg=empty'));
		elseif(in_array('existing_user_login',$error)) wp_redirect(home_url('/register?reg=sname'));	
    } else {
		auth_user_login($user_data['usermail'], $user_data['password'], 'Registration');  
		wp_redirect(home_url('/user/account'));	  
    } 	
	
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_user_register' );  

function auth_user_login($user_login, $password, $login)
{
	$info = array();
    $info['user_login'] = $user_login;
    $info['user_password'] = $password;
    $info['remember'] = true;
	
	$user_signon = wp_signon( $info, false );
    if ( !is_wp_error($user_signon) ){
		wp_set_current_user($user_signon->ID); 
		wp_redirect(home_url('/user'));
    }
	
	die();
}