<?php
// 公告
function post_type_reg() {
	
	register_post_type(
					'video', 
				array('public' => true,
					'show_in_rest' => true,
					'publicly_queryable' => true,
					'has_archive' => true, 
					'hierarchical' => false,
					'taxonomies' => array( 'post_tag','topic-types'),//实际使用的是这个分类，但是不于边栏显示
					'labels'=>array(
									'name' => _x('视频', 'jcfzw'),
									'singular_name' => _x('视频', 'jcfzw'),
									'add_new' => _x('发视频', 'jcfzw'),
									'add_new_item' => __('发视频'),
									'edit_item' => __('编辑'),
									'new_item' => __('发视频'),
									'view_item' => __('预览'),
									'search_items' => __('搜索'),
									'not_found' =>  __('没有找到可显示的内容！'),
									'not_found_in_trash' => __('回收站为空'), 
									'parent_item_colon' => ''
									),
                             'show_ui' => true,
							 'menu_icon'   => 'dashicons-book',
							 'menu_position'=> 6,	
							 //'show_in_menu' => 'edit.php',
							 'supports' => array(
												'title',
												'editor',
												'thumbnail',
												'comments',
														) ,
					)
	);	
	
	register_post_type(
					'topic', 
				array( 'public' => true,
					'show_in_rest' => true,
					'publicly_queryable' => true,
					'has_archive' => true, 
					'hierarchical' => false,	
					'taxonomies' => array( 'topic-types','post_tag' ),					
					'labels'=>array(
									'name' => _x('话题', 'jcfzw'),
									'singular_name' => _x('话题', 'jcfzw'),
									'add_new' => _x('添加话题', 'jcfzw'),
									'add_new_item' => __('添加话题'),
									'edit_item' => __('编辑话题'),
									'new_item' => __('添加'),
									'view_item' => __('预览'),
									'search_items' => __('搜索'),
									'not_found' =>  __('没有找到可显示的内容！'),
									'not_found_in_trash' => __('回收站为空'), 
									'parent_item_colon' => ''
									),
                             'show_ui' => true,
							 'menu_icon'   => 'dashicons-feedback',
							 'menu_position'=> 5,
							 'supports' => array(
												'title',
												'editor',
												'thumbnail',
												'comments',
												),
					)
	);	
	register_post_type(
					'topicreply', 
				array( 'public' => true,
					'capabilities' => array(
						'create_posts' => 'false',//Disable add new button in backstage
					  ),
					'map_meta_cap' => true,	//set false no one can edit existing post.
					'publicly_queryable' => true,
					'has_archive' => false, 
					'hierarchical' => false,
					'labels'=>array(
									'name' => _x('回应', 'jcfzw'),
									'singular_name' => _x('回应', 'jcfzw'),
									'add_new' => _x('添加回应', 'jcfzw'),
									'add_new_item' => __('添加回应'),
									'edit_item' => __('编辑'),
									'new_item' => __('添加'),
									'view_item' => __('预览'),
									'search_items' => __('搜索'),
									'not_found' =>  __('没有找到可显示的内容！'),
									'not_found_in_trash' => __('回收站为空'), 
									'parent_item_colon' => ''
									),
                             'show_ui' => true,
							 'menu_icon'   => 'dashicons-media-document',
							 'menu_position'=> 7,
							 'show_in_menu' => 'edit.php?post_type=topic',
							 'supports' => array(
												'editor',
												'comments',
												),
					)
	);	
	register_post_type(
					'lister', 
				array( 'public' => false,				
					'hierarchical' => false,
					'exclude_from_search' => true,					
					'taxonomies' => array( 'album-types' ),	
					'supports' => array('title'),						
					'labels'=>array(
									'name' => _x('幻灯', 'jcfzw'),
									'singular_name' => _x('条目', 'jcfzw'),
									'add_new' => _x('添加', 'jcfzw'),
									),
					 'show_ui' => true,
					 'menu_icon'   => 'dashicons-playlist-video',
					 'menu_position'=> 11,
					 'capabilities' => array(   
						'edit_post' => 'edit_lister', 
						'read_post' => 'read_lister',
						'edit_posts' => 'edit_listers',   
						'edit_others_posts' => 'edit_others_listers',   
						'publish_posts' => 'publish_listers',     
						'delete_post' => 'delete_lister',   
						) , 
					'map_meta_cap' => true,
					)
	);

	register_post_type(
					'album', 
				array('public' => true,
					'show_in_rest' => true,
					'publicly_queryable' => true,
					'has_archive' => true, 
					'hierarchical' => false,
					'labels'=>array(
									'name' => _x('收藏夹', 'jcfzw'),
									'singular_name' => _x('收藏夹', 'jcfzw'),
									'add_new' => _x('添加', 'jcfzw'),
									'add_new_item' => __('添加'),
									'edit_item' => __('编辑'),
									'new_item' => __('添加'),
									'view_item' => __('预览'),
									'search_items' => __('搜索'),
									'not_found' =>  __('没有找到可显示的内容！'),
									'not_found_in_trash' => __('回收站为空'), 
									'parent_item_colon' => ''
									),
                             'show_ui' => true,
							 'menu_icon'   => 'dashicons-category',
							 'menu_position'=> 5,						 
							 'supports' => array(
												'title',
												'editor',
												'thumbnail',
												'comments',
														) ,
					)
	);
	
	register_post_type(
					'torrent', 
				array( 'public' => true,
					'show_in_rest' => true,
					'publicly_queryable' => true,
					'has_archive' => true, 
					'hierarchical' => false,	
					'taxonomies' => array('post_tag' ),					
					'labels'=>array(
									'name' => _x('种子', 'jcfzw'),
									'singular_name' => _x('种子', 'jcfzw'),
									'add_new' => _x('添加种子', 'jcfzw'),
									'add_new_item' => __('添加种子'),
									'edit_item' => __('编辑种子'),
									'new_item' => __('添加'),
									'view_item' => __('预览'),
									'search_items' => __('搜索'),
									'not_found' =>  __('没有找到可显示的内容！'),
									'not_found_in_trash' => __('回收站为空'), 
									'parent_item_colon' => ''
									),
                             'show_ui' => true,
							 'menu_icon'   => 'dashicons-feedback',
							 'menu_position'=> 6,
							 'supports' => array(
												'title',
												'editor',
												'thumbnail',
												'comments',
												),
					)
	);	
	
	register_post_status( 'fold', array(
		'label'                     => _x( '折叠', '' ),
		'public'                    => true,
		'exclude_from_search'       => false,
		'show_in_admin_all_list'    => true,
		'show_in_admin_status_list' => true,
		'label_count'               => _n_noop( '折叠 <span class="count">(%s)</span>', '折叠 <span class="count">(%s)</span>' ),
	) );	
	
}

add_action('init', 'post_type_reg');


/**
 * 将一些自定义状态加入quick-edit面板
 * https://rudrastyh.com/wordpress/custom-post-status-quick-edit.html
 */

add_action('admin_head-edit.php','rudr_status_into_inline_edit');
 
function rudr_status_into_inline_edit() { // ultra-simple example

	    ?>       
    <style type="text/css">         
		#wpbody-content .quick-edit-row-post .inline-edit-author{ display:none; } 
    </style>
    <?php

 	$screen = get_current_screen();
	
	if( 'topicreply' == $screen->post_type ) { 
		
	echo "<script>
	jQuery(document).ready( function() {
		jQuery( 'select[name=\"_status\"]' ).append( '<option value=\"fold\">折叠</option>' );
	});
	</script>";
	
	    ?>       
    <style type="text/css">         
    	#wpbody-content .quick-edit-row-post .inline-edit-col-left,#wpbody-content .quick-edit-row-post .inline-edit-categories { display:none; }   	
    </style>
    <?php
	
	}
} 

//rewrite

$mytypes = array(
    'video' => 'video',
    'topic' => 'topic',
	'post' => 'post',
	'album' => 'album',
);
add_filter('post_type_link', 'custom_book_link', 1, 3); 
function custom_book_link( $link, $post = 0 ){
    global $mytypes;
    if ( in_array( $post->post_type,array_keys($mytypes) ) ){
        return home_url( $mytypes[$post->post_type].'/' .$post->post_name.'.html' );
    } else {
        return $link;
    }
}
add_action( 'init', 'cpt_rewrites_init' );
  
function cpt_rewrites_init(){
    global $mytypes;
    foreach( $mytypes as $k => $v ) {
        add_rewrite_rule(
            $v.'/([^/]+)\.html$',
            'index.php?post_type='.$k.'&name=$matches[1]',
            'top' );
    }
	//rewrite uthor link base uid below.
 	global $wp_rewrite;
    $wp_rewrite->author_base = 'uid';
}
//change uthor link default url below.
function jt_user_homepage_link( $link, $author_id, $author_nicename ) {	
		$link = esc_url_raw( home_url('uid/').$author_nicename);
		return $link;
}
add_filter( 'author_link', 'jt_user_homepage_link',10, 3 );

function create_custome_taxonomy() {

	register_taxonomy('source-types',array('post'), array(
		'hierarchical' => true,
		'labels' => array(
					'name' => _x( '来源分类', '' ),
					'singular_name' => _x( '来源分类', 'jcfzw' ),
					'search_items' =>  __( '搜索' ),
					'all_items' => __( '全部' ),
					'parent_item' => __( '父级分类目录' ),
					'parent_item_colon' => __( '父级分类目录:' ),
					'edit_item' => __( '编辑' ), 
					'update_item' => __( '更新' ),
					'add_new_item' => __( '添加新分类' ),
					'new_item_name' => __( '添加新分类' ),
					), 
		'show_ui' => true,
		'show_in_nav_menus' => true,
		'show_admin_column' => true,
		'query_var' => true,
		'show_in_rest' => true,
		'rewrite' => array( 'slug' => 'class' ),
  ));   

	register_taxonomy('topic-types',array('topic'), array(
		'hierarchical' => true,
		'labels' => array(
					'name' => _x( '类别', 'douhua' ),
					'singular_name' => _x( '类别', 'jcfzw' ),
					'search_items' =>  __( '搜索' ),
					'all_items' => __( '全部' ),
					'parent_item' => __( '父级分类目录' ),
					'parent_item_colon' => __( '父级分类目录:' ),
					'edit_item' => __( '编辑' ), 
					'update_item' => __( '更新' ),
					'add_new_item' => __( '添加新分类' ),
					'new_item_name' => __( '添加新分类' ),
					), 
		'show_ui' => true,
		'show_admin_column' => true,
		'show_in_nav_menus' => true,
		'show_in_menu' => 'edit.php?post_type=topic',
		'query_var' => true,
		'show_in_rest' => true,
		'rewrite' => array( 'slug' => 't' ),
  ));    
}
add_action( 'init', 'create_custome_taxonomy', 0 );

/**
 * rebuild post list pannel
 */
	 
 function custom_post_columns( $defaults ) {
    $defaults = array(
		'cb' => '<input type="checkbox"/>',
        'appoint_index' => 'ID',			
        'title' => '名称',		
        'author' => '作者/编辑',		
        'date' => '日期',	
        'taxonomy-category' => '分类',	
		'topicat' => '第二分类',
        'belongto' => '归集',
        'views' => '浏览',		
		'featuredimage'=> '封面图',			
        'laiyuan' => '来源',
		'hot_position'=> '热点推送',	
		
     );
    return $defaults;
}
add_filter('manage_post_posts_columns' , 'custom_post_columns',5);
add_filter('manage_video_posts_columns' , 'custom_post_columns',5);
add_filter('manage_topic_posts_columns' , 'custom_post_columns',5);
add_filter('manage_topicreply_posts_columns' , 'custom_post_columns',5);
add_filter('manage_album_posts_columns' , 'custom_post_columns',5);


function custom_post_columns_data( $column_name, $post_id ) {
	global $post;
    switch ( $column_name ) {
	case "appoint_index":
		$index = $post_id;
		$status = get_post($post_id)->post_status;
		if($status == 'fold') $index = '<span class="item_index fold_index"><strong style="color:red">'.$post_id.'<br/>已折叠</strong></span>';	
		 echo $index;
		 break; 
	case "topicat":
	 $terms = wp_get_post_terms($post_id,'topic-types');
		 if ($terms) {
			foreach($terms as $term){
				echo '<b>'.$term->name.'</b><br/>';	
			}
		 }
	  break;
	case "belongto":
	 $scholars = get_post_meta($post_id,'specialist',true);
		 if ( empty( $scholars) ) {			 
			 echo '—';			 
		 } else {
			 foreach($scholars as $scholar){
				echo '<b>'.get_post($scholar)->post_title.'</b><br/>';	
			 }
		 }
	 break;
	case "featuredimage":
		if ( has_post_thumbnail() ) { echo '已设置'; } else { echo '—';}
	 break;	
	case "laiyuan":
	 $custom = get_post_meta( $post_id,'copyright',true);
	 if($custom=='k'){echo '期刊';}elseif($custom=='k'){echo '网络';}else{echo '原创';}
	 break;	
	case "hot_position":
	 $sticky = get_post_meta( $post_id,'if_rcd',true);
     if ( $sticky == 'homerec' )	 {  echo '编辑推荐';} 
     elseif ( $sticky == 'picsticky' )	 {  echo '图片热点';} else { echo '—';} 
	 break;	
	}
}
add_action( 'manage_post_posts_custom_column' , 'custom_post_columns_data', 5, 2 ); 
add_action( 'manage_video_posts_custom_column' , 'custom_post_columns_data', 5, 2 );
add_action( 'manage_topic_posts_custom_column' , 'custom_post_columns_data', 5, 2 );
add_action( 'manage_topicreply_posts_custom_column' , 'custom_post_columns_data', 5, 2 );
add_action( 'manage_album_posts_custom_column' , 'custom_post_columns_data', 5, 2 );

/**
 * 为文章类型 picture 设置metabox
 */

add_action('admin_init', 'bno_lister_init');

function bno_lister_init(){
	add_meta_box("bno_lister_lists", __('设置','bno'), "bno_lister_lists", "lister", "normal", "high");
}


function bno_lister_lists(){
	global $post;
	$custom = get_post_custom($post->ID);
	$lister='';
	if($custom)$lister = unserialize( $custom["custom_lister"][0] );

	wp_print_scripts('media-upload');
	wp_enqueue_script('thickbox');
	wp_enqueue_style('thickbox');
	
	?>
	<script>
		jQuery(document).ready(function() {
			
			jQuery(function() {
				jQuery( "#bno-lister-items" ).sortable({placeholder: "ui-state-highlight"});
			});

			function custom_lister_uploader(field) {
				var button = "#upload_"+field;
				jQuery(button).click(function() {
					window.restore_send_to_editor = window.send_to_editor;
					tb_show('', 'media-upload.php?referer=bno-settings&amp;type=image&amp;TB_iframe=true&amp;post_id=0');
					bno_set_lister_img(field);
					return false;
				});

			}
			function bno_set_lister_img(field) {
				window.send_to_editor = function(html) {
					imgurl = jQuery('img',html).attr('src');
					
			if(typeof imgurl == 'undefined') // Bug fix By Fouad Badawy
				imgurl = jQuery(html).attr('src');
			
			
			classes = jQuery('img', html).attr('class');
			if(typeof classes != 'undefined')
				id = classes.replace(/(.*?)wp-image-/, '');
			
			if(typeof classes == 'undefined'){ // Bug fix By Fouad Badawy
				classes = jQuery(html).attr('class');
				if(typeof classes != 'undefined')
					id = classes.replace(/(.*?)wp-image-/, '');
			}
			
			jQuery('#bno-lister-items').append('<li id="listItem_'+ nextCell +'" class="ui-state-default"><div class="widget-content option-item"><div class="lister-img"><img src="'+imgurl+'" alt=""></div><label for="custom_lister['+ nextCell +'][title]"><span><?php _e('标题 :','bno'); ?></span><input id="custom_lister['+ nextCell +'][title]" name="custom_lister['+ nextCell +'][title]" value="" type="text" /></label><label for="custom_lister['+ nextCell +'][link]"><span style="float:left" ><?php _e('链接:','bno'); ?></span><input name="custom_lister['+ nextCell +'][link]" id="custom_lister['+ nextCell +'][link]" value="" type="text" /></label><input id="custom_lister['+ nextCell +'][id]" name="custom_lister['+ nextCell +'][id]" value="'+id+'" type="hidden" /><a class="del-cat button-primary"><?php _e('删除','bno'); ?></a></div></li>');
			nextCell ++ ;
			tb_remove();
			window.send_to_editor = window.restore_send_to_editor;
		}
	};
	
	custom_lister_uploader("add_list");
	
});
	jQuery(".del-cat").live("click" , function() {
		jQuery(this).parent().parent().addClass('removered').fadeOut(function() {
			jQuery(this).remove();
		});
	});

</script>	

	<ul id="bno-lister-items">	
	<?php
	if( $lister ){
		$i=0;
		foreach( $lister as $list ):
			$i++; ?>	
		<li id="listItem_<?php echo $i ?>"  class="ui-state-default">
			<div class="widget-content option-item">
				<div class="lister-img"><?php echo wp_get_attachment_image( $list['id'] , 'thumbnail' );  ?></div>
				<label for="custom_lister[<?php echo $i ?>][title]"><span><?php _e('标题 :','bno'); ?></span><input id="custom_lister[<?php echo $i ?>][title]" name="custom_lister[<?php echo $i ?>][title]" value="<?php  echo stripslashes( $list['title'] )  ?>" type="text" /></label>
				<label for="custom_lister[<?php echo $i ?>][link]"><span style="float:left" ><?php _e('链接:','bno'); ?></span><input name="custom_lister[<?php echo $i ?>][link]" id="custom_lister[<?php echo $i ?>][link]" value="<?php echo stripslashes($list['link']) ; ?>" type="text" /></label>
				<input id="custom_lister[<?php echo $i ?>][id]" name="custom_lister[<?php echo $i ?>][id]" value="<?php  echo $list['id']  ?>" type="hidden" />
				<a class="del-cat button-primary"><?php _e('删除','bno'); ?></a>
			</div>
		</li>
	<?php endforeach; 
}else{
	echo '<p>'.__('点击下方按钮开始添加！','bno').'</p>';
}?>
	</ul>
	<input id="upload_add_list" type="button" class="button-primary mpanel-save" value="<?php _e('添加新图片','bno'); ?>">
<script> var nextCell = <?php echo $i+1 ?> ;</script>

<?php
}

add_action('save_post', 'save_lister');

function save_lister(){
	global $post;
	
	if( @$_POST['custom_lister'] && @$_POST['custom_lister'] !=''){
		update_post_meta($post->ID, 'custom_lister' , $_POST['custom_lister']);	
		$lister = get_post_meta($post->ID,'custom_lister',true);
			foreach( $lister as $list ){
				$parent = get_post($list['id'])->post_parent;
				if($parent==0){
					wp_update_post(array( 'ID' => $list['id'],'post_parent'  => $post->ID));
				}
			}
	}
	else{ 
		if(!empty($post->ID)) delete_post_meta($post->ID, 'custom_lister' );
	}
}
 
?>