<?php
/*
 * Frontend editor, including title/content
 */

function input_after_check_set($fields,$str){
	global $post;
	$checkstatus = '';
	if(get_post_meta($post->ID,$fields,true)=='on')$checkstatus = 'checked';
	$aftercheck = '<span class="setcheck right"><input type="checkbox" class="afterCheck" id="bargain" '.$checkstatus.'><label for="bargain"></label><span class="bargain-desc">'.$str.'</span></span>';
	return $aftercheck;
}

function cmb_only_show_for_user_admin( $display, $meta_box ) {
	if ( ! isset( $meta_box['show_on']['key'], $meta_box['show_on']['value'] ) ) {
		return $display;
	}
	if ( 'user-type' !== $meta_box['show_on']['key'] ) {
		return $display;
	}
	return current_user_can( $meta_box['show_on']['value'] );
}
add_filter( 'cmb2_show_on', 'cmb_only_show_for_user_admin', 10, 2 );

function cmb_only_show_not_reply() {
	if(get_the_ID()!== 2){
		if(get_current_user_id()== get_post(get_the_ID())->post_author){
			if(isset($_GET['edit'],$_GET['action'])|| isset($_GET['new']) )	return 1;
		} else {
			return 0;
		}
	} else {
		return 1;
	}
}

function chumi_frontend_edit_form_register() {
	
	global $post;

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-post-edit-form',
		'object_types' => array( 'post' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );	


	// and prepend title
	$cmb->add_field( array(
		'name'   => __( 'Title', 'cmb2' ),
		'id'     => 'post_title',
		'type'    => 'text',		
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'在此输入标题',
		),			
		//'before' => 'jt_edit_core_maybe_redirect',
	) );

	// and content fields
	$cmb->add_field( array(
		'name'  => __( 'Content', 'cmb2' ),
		'id'    => 'post_content',
		'show_names' => false,
		'type'    => 'wysiwyg', 
		'attributes' => array(
		'class'=>'required',
		),		
		'options' => array(
			'media_buttons' => true, 
			'teeny' => true,
			'tinymce' => true, 
			'class'=>'required',
			'textarea_rows' => 25, 
			'quicktags' => false 
		),
	) );
		
	$cmb->add_field( array( //分类模块
		'name'    =>  __( '选择分类', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'terms_rdo_inline', //该函数定义在最前面
	) );
	
	$cmb->add_field( array(
		'name'    =>  __( '设置封面图片', 'cmb2' ),
		'id'      => 'post_thumbnail',
		'type'    => 'file',
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),	
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
	) );	
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加关键词' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
			'autocomplete' => 'off',
		),			
	) ); 	
 	
	$cmb->add_field( array( //站外链接
		'name' => __( '选择或注明文章版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) );

	$cmb->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入来源名称……',
			'showon'=>'w',
		),		
	) );
	$cmb->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'网址前请加上http://',
			'showon'=>'w',
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入期刊名称、期数等……',
			'showon'=>'k',//js控制
			
		),	
	) );	
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'post_script', 
	) );
	
//video 字段

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-video-edit-form',
		'object_types' => array( 'video' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );

		$cmb->add_field( array(
			'name'    => __( '选择上传或转载视频', 'cmb2' ),
			'id'      => 'video_sharemode',
			'type'    => 'video_sharemode',
		) );	

		$cmb->add_field( array(
			'id'      => 'video',
			'type'    => 'file',
			'query_args' => array(
				'type' => 'video/mp4 ', // Make library only display PDFs.
			),
			'before_field' =>input_after_check_set('add_gifplayer','启用Gif播放器(启用后将不播放视频中的声音)'),
			'attributes'  => array(		
				'autocomplete' => 'off',
				'showon'=>'video_upload',
			),				
		) );

		$cmb->add_field( array(
			'id'   => 'add_gifplayer',
			'type' => 'hidden',			
		) );
		
		$cmb->add_field( array(
			'id'      => 'videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>'video_reprint',
				'placeholder'=>'网址前请加上http://',				
			),				
		) );

		$cmb->add_field( array(
			'id'      => 'wechat_videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>'wechat_video_reprint',
				'placeholder'=>'网址前请加上http://',				
			),				
		) );	
		
		$cmb->add_field( array(
			'id'     => 'bilibili_aid',
			'type'    => 'text_number',
			'before' => '视频源ID  ',
			'show_on' => array( 'key' => 'user-type', 'value' => 'manage_options' ), 
			'attributes' => array(
				'autocomplete' => 'off', 
				'showon'=>'video_reprint',
				'placeholder'=>'sid/vid/aid……',
			),			
		) );		

		$cmb->add_field( array(
			'id'     => 'bilibili_cid',
			'type'    => 'text_number',
			'before' => '视频源辅助ID  ',
			'show_on' => array( 'key' => 'user-type', 'value' => 'manage_options' ),
			'attributes' => array(
				'autocomplete' => 'off', 
				'showon'=>'video_reprint',
				'placeholder'=>'cid……',
			),			
		) );		
		
		// and prepend title
		$cmb->add_field( array(
			'name'   => __( '视频标题', 'cmb2' ),
			'id'     => 'post_title',
			'type'    => 'text',
			'attributes' => array(
				'autocomplete' => 'off', 
				'class'=>'required',
				'placeholder'=>'在此输入视频标题……',
			),			
			//'before' => 'jt_edit_core_maybe_redirect',
		) );

		// and content fields
		$cmb->add_field( array(
			'name'  => __( '视频简介', 'cmb2' ),
			'id'    => 'post_content',
			'type'    => 'textarea', 
			'attributes' => array(
				'id'=>'submitted_post_content',
				'rows' => 3, 
			),		
		) );		
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) ); 

	$cmb->add_field( array( 
		'name'    =>  __( '为视频选择一个最恰当的类别', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'topic_mode', 
	) );	
 	
	$cmb->add_field( array( //站外链接
		'name' => __( '选择或注明版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) );

	$cmb->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入来源名称……',
			'showon'=>'w',
		),		
	) );
	$cmb->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'网址前请加上http://',
			'showon'=>'w',
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入期刊名称、期数等……',
			'showon'=>'k',//js控制
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'video_script', 
	) );
	

//for topic
	$cmb_topicreply = new_cmb2_box( array(
		'id'           => 'front-end-topic-edit-form',
		'object_types' => array('topic'),
		'hookup'       => false,
		'cmb_styles' => false,		
		'save_fields'  => false,
	) );
	
	$cmb_topicreply->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'topicreply_script', 
	) );	
	
	$cmb_topicreply->add_field( array( // 标题模块
		'name'    => __( '标题', 'chumi' ),
		'id'      => 'post_title',
		'type'    => 'text',
		'show_on_cb' => 'cmb_only_show_not_reply',	
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'请在此输入帖子标题',
		),
	) ); 	
	
	// and content fields
  	$cmb_topicreply->add_field( array( // content moudle
		'id'      => 'topic_content',
		'type'    => 'textarea', 
		'attributes' => array(
			'class'=>'required',
			'autocomplete' => 'off',
			'rows' => 5,
			'placeholder'=>'输入帖子内容(520字内,更多内容可新增楼层)',			
		),
	) );
	
	$cmb_topicreply->add_field( array( //img url
		'name'    => '<b>网址贴图：</b>请粘贴保存在<a href="http://photo.weibo.com" target ="_blank">临时图床</a>或者<a href="http://photo.weibo.com" target ="_blank">新浪相册</a>的图片网址。不了解如何贴图？<a class="helplink" href="">查看教程</a><span class="cmb-add-row"><button type="button" data-selector="topic_imgurls_repeat" class="cmb-add-row-button">增加行</button></span>',
		'id'      => 'topic_imgurls',
		'type'    => 'text_link',
		'repeatable' => true,
		'sortable'   => true,
		'classes' => 'topic-url-input',
		'attributes'  => array(		
			'autocomplete' => 'off',
			//'class'=>'required',
		),			
	) );
	
	$cmb_topicreply->add_field( array( 
		'name'    =>  __( '为帖子选择一个最恰当的类别', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'topic_mode', 
		'show_on_cb' => 'cmb_only_show_not_reply',
	) );
	
	$cmb_topicreply->add_field( array( //标签
		'name'    =>  __( '帖子标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'show_on_cb' => 'cmb_only_show_not_reply',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) );
	
//for torrent
	$cmb_tt = new_cmb2_box( array(
		'id'           => 'front-end-torrent-edit-form',
		'object_types' => array('torrent'),
		'hookup'       => false,
		'cmb_styles' => false,		
		'save_fields'  => false,
	) );	

	$cmb_tt->add_field( array(
		'name'    => __( '输入不同分类的磁力链或url', 'cmb2' ),
		'id'      => 'torrent_type',
		'type'    => 'torrent_type',
	) );

$group_field_id = $cmb_tt->add_field( array(
	'id'          => '4k',
	'type'        => 'group',
	'options'     => array(
		//'group_title'   => __( '资源{#}', 'cmb2' ), // since version 1.1.4, {#} gets replaced by row number
		'add_button'    => __( 'Add Another Entry', 'cmb2' ),
		'remove_button' => __( 'Remove Entry', 'cmb2' ),
		'sortable'      => true, 
	),
	'attributes'  => array(		
			'showon'=>'4k',				
		),	
) );

$cmb_tt->add_group_field( $group_field_id, array(
	//'name' => '资源类别',
	'show_names' => false,
	'id'             => 'type',
	'taxonomy'       => 'category', //Enter Taxonomy Slug
	'type'           => 'taxonomy_select',
	'remove_default' => 'true',
	'attributes'  => array(		
		'autocomplete' => 'off',
		'class'=>'required',				
	),	
) );	

$cmb_tt->add_group_field( $group_field_id, array(
	//'name' => '资源标题',
	'id'   => 'title',
	'type' => 'text_medium',
	'show_names' => false,
	'attributes'  => array(		
		'autocomplete' => 'off',
		'placeholder'=>'输入资源名称并选择类别',	
	),	
) );

$cmb_tt->add_group_field( $group_field_id, array(
	//'name' => '资源大小',
	'show_names' => false,
	'id'             => 'size',
	'type'           => 'text_number',	
	'attributes'  => array(		
		'autocomplete' => 'off',
		'class'=>'required',
		'placeholder'=>'GB',				
	),	
) );

$cmb_tt->add_group_field( $group_field_id, array(
	//'name' => '链接或磁力链',
	'id'   => 'url',
	'type'    => 'text_link',
	'show_names' => false,
	'attributes'  => array(		
		'autocomplete' => 'off',
		'class'=>'required',
		'placeholder'=>'网址前请加上http(s)://',				
	),
) );
	
	// and prepend title
	$cmb_tt->add_field( array(
		//'name'   => __( '资源标题', 'cmb2' ),
		'id'     => 'post_title',
		'type'    => 'text',
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'在此输入视频标题……',
		),			
		//'before' => 'jt_edit_core_maybe_redirect',
	) );

	// and content fields
	$cmb_tt->add_field( array(
		'name'  => __( '简介', 'cmb2' ),
		'id'    => 'post_content',
		'type'    => 'textarea', 
		'attributes' => array(
			'id'=>'submitted_post_content',
			'rows' => 3, 
		),		
	) );		
	
	$cmb_tt->add_field( array( //标签
		'name'    =>  __( '添加标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) ); 

	$cmb_tt->add_field( array( 
		'name'    =>  __( '选择一个类别', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'topic_mode', 
	) );
	
	$cmb_tt->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'video_script', 
	) );
	
}

add_action( 'cmb2_init', 'chumi_frontend_edit_form_register' ); 

function jt_add_edit_form_to_frontend( $content ) {
	
	if ( isset( $_GET['edit'] ) && current_user_can('edit_posts') ) {
		if (is_singular( 'post') && wp_verify_nonce( $_GET['edit'], 'edit' )) {//文章
			$content = cmb2_get_metabox_form( 'front-end-post-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );
		} elseif (is_singular( 'topic') && wp_verify_nonce( $_GET['edit'], 'edit' )) {//topic
			$content = cmb2_get_metabox_form( 'front-end-topic-edit-form', get_the_ID(),array( 'save_button' => __( '提交修改', 'chumi' ) ) );
		} elseif (is_singular( 'video') && wp_verify_nonce( $_GET['edit'], 'edit' )&& !isset($_GET['step'])) {//视频
			$content = cmb2_get_metabox_form( 'front-end-video-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );
		} else {
			$content = '<h2 class="edit-error">原来你也在这里，可这儿什么都没有</h2>';
		}

	} 
	return $content;
}
add_filter( 'the_excerpt', 'jt_add_edit_form_to_frontend' );

function jt_modify_edit_link( $link ) {	
	$cpt = get_post(get_the_ID())->post_type;
 	if ( !is_admin() &&( $cpt == 'topic' || $cpt == 'post' || $cpt == 'video') )
		$link = esc_url_raw( wp_nonce_url( get_permalink(get_the_ID()), 'edit', 'edit' ) ).'&action='.get_the_ID();
	return $link;
}
add_filter( 'get_edit_post_link', 'jt_modify_edit_link' );

function jt_user_edit_link( $link ) {		
	if(!is_admin()){
		$link = esc_url_raw( wp_nonce_url( home_url('/user/account'), 'edit', 'edit' ) );
		return $link;
	}
}
add_filter( 'get_edit_user_link', 'jt_user_edit_link' );

function jt_cmb2_override_core_field_get( $val, $object_id, $a, $field ) {

	global $post;
	
	if(!isset($_GET['new'])) {
		if ( in_array( $field->id(), array( 'post_title', 'post_content' ), true ) ) {
			if ( isset( $post->ID ) ) {
				$val = get_post_field( $field->id(), $post );
			} else {
				$val = '';
			}
		}
	}

	return $val;
}
add_filter( 'cmb2_override_meta_value', 'jt_cmb2_override_core_field_get', 10, 4 );


function chumi_handle_frontend_edit_post() {

	if ( !is_user_logged_in() || empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	
	$metabox_id = 'front-end-post-edit-form';	
	$current_url = home_url(add_query_arg(array()));
	if(strpos($current_url,'_thread')==true)//_thread is important for post_name
		$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'_thread')-strpos($current_url,'_')-1);
	$cmb = cmb2_get_metabox( $metabox_id, $object_id);

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['post_content'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写文章内容后再提交' ) ) );
	}		

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title']   = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
	$post_data['post_parent'] = $sanitized_values['parent'];	
	unset( $sanitized_values['parent'] );
		
	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );

	$category = get_term_by( 'id',$cat,'category')->name;
	if(empty($category)){$category = get_the_category($object_id)[0]->cat_name;}		
	
	wp_set_object_terms( $object_id, $category, 'category');

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'post_parent'=>$post_data['post_parent'],
		'_thumbnail_id' => $sanitized_values['post_thumbnail_id'],
		'post_status' => 'pending',
	) );

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}
		
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}	
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','action','type'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_post' );

function chumi_handle_frontend_edit_video() {
	
	if ( !is_user_logged_in() || empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}	

	$metabox_id = 'front-end-video-edit-form';
	$current_url = home_url(add_query_arg(array()));	
	if(strpos($current_url,'_thread')==true)//_thread is important for post_name
		$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'_thread')-strpos($current_url,'_')-1);
		
	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['fake_video'] ) && empty($_POST['video_id']) && empty($_POST['wechat_videouri']) && empty($_POST['videouri']) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请添加视频连接或文件！' ) ) );
	}

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title'] = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'_thumbnail_id'=> get_post_meta($sanitized_values['video_id'],'_thumbnail_id',true),
		'post_status' => 'pending',
	) );
	
	$aid_url=$sanitized_values['videouri'];
	if(strpos($aid_url,'bilibili.com') > 0 || strpos($aid_url,'hdslb.com') > 0 ) {
		if(strpos($aid_url,'av') > 0 && strpos($aid_url,'?') > 0) $aid = substr($aid_url,strpos($aid_url,'av')+2,strpos($aid_url,'?')-strpos($aid_url,'av')-3);
		if(strpos($aid_url,'av') > 0 &&  strpos($aid_url,"?") < 1) {$aid = substr($aid_url,strpos($aid_url,"av")+2);$aid = substr($aid,0,strpos($aid,"/"));}
		if(strpos($aid_url,'aid') > 0) $aid = substr($aid_url,strpos($aid,"aid")+3);
		
		update_post_meta( $object_id, 'bilibili_aid', $aid );
	}
	
	$vid_url=$sanitized_values['wechat_videouri'];
	if(strpos($vid_url,'qq.com') > 0 && strpos($vid_url,'html') > 0) {
		$vid=substr($vid_url,strpos($vid_url,'html')-12,11);	
		update_post_meta( $object_id, 'qq_vid', $vid );
	}

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}
	
	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );
	$category = intval($cat);
	$exist_cats = get_the_terms($object_id,'topic-types');
	if(empty($category)) {
		$category = get_term_by('slug','t-2','topic-types')->term_id;//new:t-2 default
		if(!empty($exist_cats[0]))$category = $exist_cats[0]->term_id;//edit:max 1 cat

	}
	wp_set_object_terms( $object_id, $category, 'topic-types');	

	/**
	 * 将附件附加到新生成的文章ID里
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		$thumb_id = get_post_meta($object_id,'_thumbnail_id',true);//父级封面
		
        if( get_post_type( $object_id ) == 'video' && $user_id ){ // set 'post', 'page', or your custom posttype

			$file_id = $sanitized_values['video_id'];	
			$author = get_post($file_id)->post_author;//作者
			$file_parent = get_post($file_id)->post_parent;//父级
				
                if (( $author == $user_id && $file_parent == 0)||$file_parent == $object_id){//若本就是父级则无需确认作者
                    $at_post = array();
                    $at_post['ID'] = $file_id;
					$at_post['post_title'] = $post_data['post_title'];//与父级标题一致
					$at_post['_thumbnail_id'] = $thumb_id;//与父级封面一致
                    $at_post['post_parent'] = $object_id; // set post_parent
                    wp_update_post( $at_post );
                }

        }
    }
	
	$videoid = get_post_meta($object_id,'video_id',true);//挂载的视频id
	if(!empty($videoid) ){
		$thumbnail_id = get_post_thumbnail_id( $videoid );
		wp_update_post( array( 
			'ID' => $videoid,
			'post_title'=> $post_data['post_title'],
		) );
		update_post_meta( $object_id, 'video_thumbnail_id', $thumbnail_id );
		update_post_meta( $object_id, 'video_thumbnail', wp_get_attachment_image_src( $thumbnail_id,full)[0] );

		if(has_post_thumbnail($object_id) == false)
			wp_update_post( array('ID' =>  $object_id,'_thumbnail_id' => $thumbnail_id) );
	}
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','action','type'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_video' );

function chumi_handle_frontend_edit_topic() {

	if ( !is_user_logged_in() || empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-topic-edit-form';	
	$object_id  = 'fake-id';
	
	$current_url = home_url(add_query_arg(array()));
	if(strpos($current_url,'_thread')==true)//_thread is important for post_name
		$real_id = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'_thread')-strpos($current_url,'_')-1);
	
	if(isset($_GET['edit'])) $object_id = $real_id;
	$cmb = cmb2_get_metabox( $metabox_id, $object_id ); 

	$post_data = array();
	
 	if ( !isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	} 
	if(isset($_GET['edit'],$_GET['action'])|| isset($_GET['new']) ){
		if ( empty( $_POST['post_title'] ) ) {
			return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写标题后再提交！' ) ) );
		} 
	}else {
		if ( empty( $_POST['topic_content'] )&& empty( $_POST['topic_imgurls'] ) ) {
			return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '回复不能为空！' ) ) );
		} 
	}

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title'] = $sanitized_values['post_title'];
	  unset( $sanitized_values['post_title'] );
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	  unset( $sanitized_values['submitted_post_tag'] ); 
	  
	$post_data['post_status'] = 'publish';
	$post_data['post_type'] = 'topic';

	$cat = intval($sanitized_values['submitted_post_cat']);	
		unset( $sanitized_values['submitted_post_cat'] );
	$exist_cats = get_the_terms($object_id,'topic-types');
	if(empty($cat)) {
		$cat = get_term_by('slug','t-2','topic-types')->term_id;//new:t-2 default
 		if($exist_cats[0]->term_id == 63 ) {
			if(!empty($exist_cats[1]))$cat = $exist_cats[1]->term_id;//edit:max 2 cats
		} else {
			if(!empty($exist_cats[0]))$cat = $exist_cats[0]->term_id;//edit:max 1 cat
		} 
	}

	$img_urls = $sanitized_values['topic_imgurls'];	
		unset( $sanitized_values['topic_imgurls'] );
	foreach($img_urls as $k => $v){
		
		if(strpos($v,'sinaimg')==true){ //判断是否新浪图片
		
			$breakurl = substr($v,stripos($v,'.cn/')+4);
			$breakurl2 = substr($breakurl,'0',stripos($breakurl,'/'));
			$largsize = str_replace($breakurl2,'large',$v);
			
			if(preg_match('/.*(\.gif)$/', $v) && isAnimatedGif($v)!==false){
				$gifthumb = str_replace($breakurl2,'small',$v);
				$c_gif .= '<img src="'.$gifthumb.'" data-gif="'.$largsize.'" class="gifs" alt="'.$post_data['post_title'].'" title="'.$post_data['post_title'].'"/>';
				$realgif .= 'yes';
			} else {
				$c_img .= ' <li class="image-flex"><img src="'.$largsize.'" alt="'.$post_data['post_title'].'" class="topicimg" title="'.$post_data['post_title'].'" /></li>';
			}
			
			$img_urls[$k] = $largsize;
			
		} else {
			if((exif_imagetype($v)==IMAGETYPE_JPEG)||(exif_imagetype($v)==IMAGETYPE_PNG) ) {
				$c_img .= '<li class="image-flex"><img src="'.$v.'" alt="'.$post_data['post_title'].'" class="topicimg" title="'.$post_data['post_title'].'" /></li>';
			}
		}
		
		if((strpos($v,'music.163.com')!==false)||(strpos($v,'xiami.com')!==false)) {//判断是否来自虾米或网易云
			$v = str_replace('https','http',$v);
			$c_music .= '<p>'.$v.'</p>';	
		} 
	}
	$gifclass ='';
	if(!empty($c_music)) $contents .= $c_music;
	if(!empty($c_gif)) $gifclass= 'gif-images';
	if(!empty($c_gif) || !empty($c_img)) $contents .= '<div class="multi-images '.$gifclass.'">'.$c_gif.$c_img.'<div class="clear"></div></div>';

	if(!empty($sanitized_values['topic_content'])) $topic_content = $sanitized_values['topic_content'];
	$contents = $topic_content.''.$contents;//final contents
	if(strpos($realgif,'yes')!==false) $cat = array(63,$cat);//自动添加gif类别63	
	
	if(isset($_GET['new']) && $_GET['new']=='t') {//新主题
		$new_submission_id = wp_insert_post( array( 
				'post_title'=> $post_data['post_title'],
				'post_content'=> $contents,
				'tags_input'=>$post_data['tags_input'],
				'post_type' => 'topic',
				'post_status' => 'pending',
		) );
 		wp_update_post( array( 
			'ID' => $new_submission_id,
			'post_name'=> substr(md5('jswdwsxyxyzshn'.$new_submission_id), 0, 15).'_'.$new_submission_id.'_thread',
		) ); 
		update_post_meta( $new_submission_id, 'threads', '0' );
		$redirect = $new_submission_id;
		
	} elseif(isset($_GET['edit'],$_GET['action']) ) { //编辑主题
	
		wp_update_post( array( 
			'ID' => $object_id,
			'post_title'=> $post_data['post_title'],
			'post_content'=> $contents,
			'tags_input'=>$post_data['tags_input'],
			'post_name'=> substr(md5('jswdwsxyxyzshn'.$object_id), 0, 15).'_'.$object_id.'_thread',			
		) );
		$redirect = $new_submission_id = $object_id;	
 	} else {//主题回复
		$new_submission_id = wp_insert_post( array(
			'post_title'=> 'parent'.$real_id.'-user'.get_current_user_id().'-time'.time(),
			'post_content'=> $contents,
			'post_parent' => $real_id ,	
			'post_type' => 'topicreply',
			'post_status' => 'publish',
		) );
 		wp_update_post( array( 
			'ID' => $new_submission_id,
			'post_name'=> substr(md5('jswdwsxyxyzshn'.$new_submission_id), 0, 15).'_'.$new_submission_id.'_thread',
		) ); 
		update_post_meta( $new_submission_id, 'vote-up_count', '1' );
		$thread_num = get_post_meta($real_id,'floor_tid',true);
		$thread_num = $thread_num['floor']+1;
		update_post_meta( $new_submission_id, 'thread_num', $thread_num);
		$tdinfo['floor'] = $thread_num;
		$tdinfo['tid'] = $new_submission_id;
		update_post_meta( $real_id,'floor_tid', $tdinfo);
		$post_data['post_title'] = get_the_title($real_id);
		$redirect = $real_id;
	} 	
	
	wp_set_object_terms( $new_submission_id, $cat, 'topic-types');
	
	foreach($img_urls as $img_url){
		if(strpos($img_url,'douhua')== false){ //判断是否本地图片
			if((exif_imagetype($img_url)==IMAGETYPE_JPEG)||(exif_imagetype($img_url)==IMAGETYPE_PNG)||(strtolower(end(explode('.',$img_url)))=='mp4')||(strtolower(end(explode('.',$img_url)))=='webm')){
				$img_id = get_media_downloader($new_submission_id,$img_url,'topic');
			}
		}
	}
	$newimages = get_attached_media( '', $new_submission_id);//image video audio，blank for all type
	if(count($newimages) !== 0) {
		foreach($newimages as $newimg){
			foreach($img_urls as $k => $v) {
				if($v === $newimg->post_title)$img_urls[$k] = wp_get_attachment_url( $newimg->ID ); 
			}			
			if(stripos($contents,$newimg->post_title)!== false){//判断地址是否被包含，如果是则替换
				if(stripos($newimg->post_title, 'http') !== false )$contents = str_replace($newimg->post_title,wp_get_attachment_url( $newimg->ID ),$contents);//如果title是url的话就进行替换；
				wp_update_post(array('ID'=>$newimg->ID,'post_title'=>$post_data['post_title']));
			}
		}
		wp_update_post(array('ID'=>$new_submission_id,'post_content'=>$contents));
	}
	
	update_post_meta( $new_submission_id, 'topic_imgurls', $img_urls );
	
	if ( is_wp_error( $new_submission_id ) ) {
		return $cmb->prop( 'submission_error', $new_submission_id );
	}
	
	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $new_submission_id, $key, $value );
			}
		} else {
				update_post_meta( $new_submission_id, $key, $value );
		}
	}
	//topic_content 如果之前有内容后来删除 也就是值为空的情况会导致数据不更新
	if(empty($sanitized_values['topic_content']))delete_post_meta( $new_submission_id, 'topic_content');
	
	if( $_GET['new']=='t' || isset($_GET['edit'],$_GET['action']) ) {
		wp_redirect(home_url( '/?p='.$redirect));
	} else{
		$trul = bno_topicreply_link($new_submission_id);
		$trul = $trul['page'];
		update_post_meta( $real_id,'last_thread_url', $trul);
		wp_redirect($trul);
	}		
	
	exit;
}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_topic' );

function isAnimatedGif($filename) {
    $fp = fopen($filename, 'rb');
    $filecontent = fread($fp, filesize($filename));
    fclose($fp);
    return strpos($filecontent, chr(0x21) . chr(0xff) . chr(0x0b) . 'NETSCAPE2.0') === FALSE ? 0 : 1;
}